<?php

defined( 'ABSPATH' ) or exit;   // show a blank page if try to access this file directly

require_once( EWZ_PLUGIN_DIR . "classes/validation/ewz-input.php" );

/* Validation for the Admin Download Ratings Spreadsheet  */

class Ewz_Rating_Spreadsheet_Input extends Ewz_Input {

    function __construct( $form_data ) {
        parent::__construct( $form_data );
        // assert( is_array( $form_data ) );
        
        $this->rules = array(
            'rating_form_id'    => array( 'type' => 'to_seq',      'req' => true, 'val' => ['len' => 8] ),
            'ss_style'          => array( 'type' => 'limited',     'req' => true, 'val' => array('I','R' ) ),
            'ewzmode'           => array( 'type' => 'fixed',       'req' => true,  'val' => 'rspread'),
            'ewznonce'          => array( 'type' => 'anonce',      'req' => true,  'val' => '' ),
            'overwrite'          => array( 'type' => 'v_overwrite', 'req' => false, 'val' => ['len' => 10] ),
            '_wp_http_referer'  => array( 'type' => 'to_string',   'req' => false, 'val' => '' ),
        );

        $this->validate();
    }
    
    function v_overwrite(&$value, $arg ){
        // assert( is_array( $value ) || empty( $value ) );
        // assert( isset( $arg ) );
        if( !is_array( $value ) ){
            throw new EWZ_Exception( 'Invalid  value for overwrite column.' );
        }
        foreach( $value as $rfield_id => $column ){
            if( !is_int($rfield_id ) ){
                 throw new EWZ_Exception( "Bad value '$rfield_id' for rating field" );
             }
            list($old_id, $col) = explode(',', $column);
            if( !is_numeric($old_id ) ){
                 throw new EWZ_Exception( "Bad value '$old_id' for old rating field" );
             }
            if(!is_numeric($col ) || !( $col >= -1 && $col < 1000 ) ){
                throw new EWZ_Exception( "Bad value '$col' for column." );
            }     
            $value[$rfield_id] ="$old_id,$col";
         }
         return true;
     }

}

