<?php
defined( 'ABSPATH' ) or exit; 

function ewz_rating_help_links(){
?>
<li class='ewzpagelink'>
<a href='#helpschemes'>Rating Schemes</a></li>
<li class='ewzpagelink'><a  href='#helpratingforms'>Rating Forms</a></li>
<?php
}
function ewz_rating_help(){
?>
 <a id='helpschemes' name='helpschemes'></a>
 <hr class='ewzhelpdiv'>
<div class='d1'>
<H1>  Schemes </H1>
            <p>The EntryWizard "Rating" system is designed for viewing and/or judging the uploaded images. 
               The Rating Form is the screen generated by the 'ewz_rating' shortcode. 
               It displays selected images together with whatever information you wish the judges to see, and any 
               input fields you wish the judges to fill out.</p>
            <p>So long as there is only one rating form on the page, the judges may, with a few exceptions, sort the images by any of the fields displayed or filled out.</p>
            <p>A Rating Scheme describes the format of the rating form the way a layout describes the format of a WebForm.</p>
            <p>It is, however, just a little more complicated. For each item you have the possibility not only of asking for various forms of input information, but also of displaying, in a read-only fashion, any of the fields originally uploaded with the item, and/or associated "extra" data fields.  </p>
            <p>Because it deals with the fields filled out when the image was uploaded, a rating scheme must be associated with a specific layout, and may only be used for items uploaded using that layout.</p>
            <p>A rating Scheme is visible to, and editable by, anyone who has EntryWizard permissions to edit its associated Layout.</p>


<div class='d2'>
<H2>  Scheme Name </H2>
            <p>The scheme requires a unique name which will appear on a dropdown menu when you come to creating the rating form.</p>                 

</div>
<div class='d2'>
<H2>  Fields </H2>
               <p>To display any field read-only to the judges, drag it from the left-hand column to the right (on narrower screens, it may be "below" instead of "right").</p>
            <p>You will then be able to click on it, open the box, and fill out some information. </p>
            <p>You can specify  the header you wish to appear over the column, 
               a short (up to 15 characters ) identifier that will be used as a column header in the downloaded spreadsheet, 
               and the column of the spreadsheet in which the data is to appear. 
            </p>
            <p>A field dragged in this way but <u>not yet saved</u> may be dragged back to the left. 
               Once saved, the field gets a "Delete" button which must be clicked to remove it.</p>
            <p>Each field corresponds to a column in the judging view. 
               So long as there is only one rating shortcode on a page, the judge may sort the view by any non-image column
            </p>
               <p>Note that data labelled "WP User" is visible only to admins with the wordpress "list_users" capability, or to
                 users with EntryWizard "See User Data" permission.</p>

<div class='d3'>
<H3>  Item Affected By Restrictions </H3>
            <p>Restrictions may be applied to rating fields in the same way they are applied to upload fields.</p>  
            <p>If the fields for a particular item match what is specified in the restriction, an error message will be generated 
               and the rating will not be saved.</p>
            <p>So you may, for instance, specify that if a "Comment Requested" column was checked in the original image upload, 
               the Comment column in the rating may not be left blank.
            </p> 
            <p><b>NOTE:</b> Restrictions will <b>not</b> be applied if the shortcode parameter "view" has been set to 
                            "secondary".
            </p>

</div>
<div class='d3'>
<H3>  Column Header for Web Page </H3>
           <p>This is the text that will appear at the top of the column on the rating page.</p>    

</div>
<div class='d3'>
<H3>  Data Type </H3>
           <p>For a <u>read-only</u> field, dragged in from the left-hand column, the data type shows the origin of the data displayed. 
              For an input field, it specifies the type of field -- text, checkbox, etc.</p> 
          <p>Image files display as thumbnails with links to the full-size image in a separate window.</p>    

           <p>Each <u>input</u> field contains one of the following types of user input:</p>
                        <ol>
                            <li><p><b>A text input:</b> The user may input any  piece of text,
                                   subject to the length restrictions you set.</p>
                                   <p>  To help in generating the
                                       one-item-per-line spreadsheet download, there are two characters that
                                       may not be used in such input: <b>~</b> and <b>|</b>.  
                                       If these appear in the input, they will be replaced by <b>_</b>.</p>
                                </li>
                            <li><b>A drop-down option list:</b> You choose the values that appear.
                                The user must select one of these values. </li>
                            <li><b>A checkbox:</b> 
                                The user may either check the box or leave it blank.</li>
                        </ol>

           <p>Users may alter the data they enter so long as the rating form is open. </p>


</div>
<div class='d3'>
<H3>  Field Identifier </H3>
           <p>The field identifier is used as the header for the column in the downloaded spreadsheet.
              It must consist only of letters, digits, dashes or underscores, and have at most 15 characters.
           </p>    

</div>
<div class='d3'>
<H3>  Spreadsheet Column </H3>
           <p>You may specify in which column this data is to appear in the downloaded spreadsheet.</p> 
           <p><b>NOTE:</b> If you plan to use the "one line per item" spreadsheet format, and have more than one judge, 
              <u>extra blank columns need to be allowed for</u>. </p>
             <p>Each column assigned to an item the judges fill out must be 
              followed by N-1 blank columns, where N is the number of judges. Don't forget to take into account any 
              columns assigned in the Extra Data area.<br>
              To see a summary of the assigned columns for the rating scheme, click the button below, next to the Save Changes and Delete buttons.
           </p> 

</div>
<div class='d3'>
<H3>  Required </H3>
            <p>When this is checked, the field is required. A judge will not be allowed to save a rating in which this field has not been set.</p>
            <p>Note that "Requiring" a checkbox means requiring it to be checked. 
               In that case, the checkbox may not have a "Maximum number that may be checked", and that item will be disabled.
               ( It may sometimes be more useful to use a drop-down with options "Yes" and "No" instead of a checkbox. )
            </p>

</div>
<div class='d3'>
<H3>  Append </H3>
           <p>Checking this forces the field to be displayed below the previous one instead of in its own column.</p>    
           <p>May be used to display an image title below its thumbnail.</p>   
           <p>This feature is also helpful in narrowing the rating page so that it can be displayed next to the image page even on a single monitor setup.</p>
           <p>Columns containing such fields will sort as if they were all concatented together. 
              <strong>BUT:</strong> Since column sorting is alphabetic (e.g. 10 sorts before 3.0) or numeric (10 sorts after 3.0) depending on the content found, 
              sorting may be unpredictable if numeric and text fields are  mixed in the same column. 
           </p>    

</div>
<div class='d3'>
<H3>  Divide </H3>
           <p>Some camera clubs make it a practise to require a comment on an image from only one of several judges.  This option
              makes it possible to do that.</p>
           <p>If the box is checked, then for each item only one judge will see the field. The others will see nothing.</p>    
           <p>Judge number 1 will see an item only if the item_id has remainder 1 when divided by the number of judges.</p>    
           <p>Judge number 2 will see an item only if the item_id has remainder 2 when divided by the number of judges, .. etc...<br>
              ( Judges are numbered by the order of their login names ).</p>    
           <p>Restrictions are enforced only on fields that are displayed.</p>  
           <p>Thus you may create a "Comment" text input, make it required, and check the "divide" flag.  
              Every item should then get a comment from one, and only one, judge. </p>
           <p>If you have been using the approach of putting a "comment requested" field in the upload layout, you could do this:</p>
               <ul class="ewz_lpad"><li> Display the "comment requested" field to the judges with "divide" checked, so only one judge sees it for each item</li>
                <li>Leave the Comment field optional. </li>
                <li>Add a restriction that the combination "Comment Requested is checked"  and "Comment is blank" is not acceptable</li>
               </ul>
           <p style="padding-left: 35px;">The comment will then be required if the "comment requested" flag was checked, and otherwise optional.</p>  
           <p>The division between judges may not be perfectly even, but in most cases should be comparable. You can see the division by downloading
              the spreadsheet - the judge who can see the field is shown in parentheses in the field column.</p>
           <p> </p>
           <p><b>If you use this feature, any change to the judge selection will change the division of this field between them.</b>
              If a substitution is necessary after the first ratings have been created, it would be better to give the new judge 
              the old judge's login.</p>
           <p><u>This choice has no effect if "Image Owner" is among your judge selections.</u></p>

</div>
<div class='d3'>
<H3>  Secondary </H3>
           <p>Once you have some or all ratings created, you may need to obtain further information about an item from a judge.
              ( The most common situation would be needing to break ties. )</p>
           <p>In the normal rating view ( 'view="rate"' or no 'view' parameter in the shortcode -- see the Help at the top of the 
              rating forms page ), a field with this box checked is not displayed at all.</p>
           <p>Using the additional parameter 'view="secondary"' in the shortcode will display all the other fields read-only,
              but fields with "secondary" checked will be editable.  Thus you can ask a judge to choose which of several images is 
              the best, or add an additional score.  Normally you would also specify a list of item_ids, and perhaps a list of judge_ids.
           </p>
           <p><b>NOTE:</b> Restrictions may not be applied on fields with the "Secondary" flag set.</p>

</div>
<div class='d3'>
<H3>  Text Field </H3>
<div class='d4'>
<H4>  Maximum Number of Characters </H4>
            <p>The user will not be able to type more than this many characters in the text box.</p>

</div>
<div class='d4'>
<H4>  Number of Lines of Visible Text </H4>
            <p>If this is set to a number greater than one, a multi-line "text area" input field is generated,
               instead of a single-line text input.  In that case, the "Number of Characters Visible in One Line" is interpreted
               as the width of the text area.
            </p>

</div>
<div class='d4'>
<H4>  Number of Characters Visible in One Line </H4>
          <p>This controls the width of the text box ( the number of characters ). </p>
          <p>If you have many fields, you may need to keep the total width of your form in mind
             when setting this value.
          </p>
          <p>On the other hand, a box that is smaller than the number of characters the user
             wishes to type is not very comfortable to use. If you need many more characters
             than the width of your form allows, try setting the "Number of Lines" to something
             bigger than 1. That creates a "textarea" instead of a normal text input.
          </p>

</div>
<div class='d4'>
<H4>  Spreadsheet Column for Formatted Text </H4>
          <p>If a column is selected, that column in the spreadsheet will contain this item
             re-formatted so that each word starts with a capital letter.
          </p>
          <p>Useful for titles used in displays.</p>
          <p>( The text is shown unchanged if it already contains both upper and lower-case characters. )</p>

</div>
</div>
<div class='d3'>
<H3>  Check Box </H3>
<div class='d4'>
<H4>  Maximum Number </H4>
          <p>The maximum number of items in the rating form that may have this checkbox checked by a single judge.</p>

</div>
<div class='d4'>
<H4>  Labels </H4>
          <p>In a read-only view, by default a checked checkbox displays as "checked", and an unchecked on as " - ".  
             You may replace these with any text of your choice that consist only of letters, digits, dashes, periods, spaces and underscores.
          </p>

</div>
</div>
<div class='d3'>
<H3>  Fixed-Text Label </H3>
          <p>The text to display on the page.  If the field is "divided between judges", this text will display only to the judge assigned to the item.  Otherwise it will display the same to all judges.
          </p>

</div>
<div class='d3'>
<H3>  Option List </H3>
<div class='d4'>
<H4>  Options </H4>
           <p>For each option you create, you need to select: </p>
               <ul class="ewz_lpad">
                  <li><b>Label for Web Page:</b> the label that is displayed in the drop-down
                      list the user selects from.<br>
                      If you have many fields, you may need to keep the total width of your
                      form in mind when setting this value.<br>
                      May contain only letters, digits, dashes, periods and underscores</li>
                 <li><b>Value for Spreadsheet:</b> what you see in the corresponding
                      spreadsheet column when the user selects this item.<br>
                      May contain only letters, digits, dashes, periods and underscores<br>
                      (Behind the scenes, this is also the value stored in the database)<br>
                      <i>Hint:</i> When you set the Label, if the Value has not already been set it defaults 
                      to that of the Label. If you want different values for Label and Value, try setting the Value first.
                 </li>
              </ul>
              Use the 'X' button to delete an option.  
             To change the position of an option, click next to it to select it, then use the up/down arrows to move it.          

</div>
<div class='d4'>
<H4>  Variance </H4>
              <p>When there are multiple judges, it is often useful to know how well they agree on the score for an image.</p>
              <p>For completely numeric options, <b>when using the "1 row per item" form of spreadsheet only</b>, this column will report
                 the difference between the largest and smallest value chosen by the judges.</p>
              <p>It is most useful for completely numeric values, but for non-numeric values it will show "=" if all judges agree, and "X" if they do not.</p>

</div>
</div>
<div class='d3'>
<H3>  Add A Field </H3>
           <p>Click on one of these buttons to add a new input field that the judge may fill out.
              Click on the new field to open it up and set its parameters.
           </p> 
           <p>The "Fixed Text Label" is only going to be of much use if the field is to be divided among the judges.  In that case, it 
              will only be displayed if the item is assigned to the judge. So, for instance, you can create a label with the content 
             "Comment Required", and add a restriction that the comment field may not be blank if the label field is not blank.
              This allows you to have a comment field that is normally optional, but that is required for items assigned to the judge.</p>
            <p>Each field corresponds to a column in the judging view. 
               So long as there is only one rating shortcode on a page, the judge may sort the view by any non-image column</p>

</div>
</div>
<div class='d2'>
<H2>  Restrictions </H2>
           <p>Restrictions may be applied to rating fields in the same way they are applied to upload fields.</p> 
  
          <p>Normally, any combination of allowed entry field values is allowed.
              There may, however, be occasions where you wish to disallow some particular combination.
          </p>
          <p>You may, for instance, specify that if a "Comment Requested" column was checked in the original image upload,
             the Comment column in the rating may not be left blank.
          </p>
          <p>To do this, you may create a restriction forbidding the combination
             <i>Comment Requested = checked </i> and <i>Comment = Blank</i>, with the message
             "A comment is required for this item.".
          </p>
          <p>If a user clicks "Save" when any item has one of these forbidden combinations,
             your message will pop up and the rating will not be saved.
          </p>
          <p><br><b>Set up all your fields and click "Save Changes" first before adding
             any restrictions</b>.  Once a field has had a restriction placed on it,
             some items within the field may no longer be edited. These fields are
             indicated by a red outline. If you need to change them, you must first
             delete the restriction.
          </p>
          <p><b>NOTE:</b> Restrictions may <b>not</b> be applied on fields with the "Secondary" flag set.
             Restrictions will <b>not</b> be enforced if the shortcode parameter "view" has been set to 
                            "secondary"</p>

<div class='d3'>
<H3>  Restriction Message </H3>
           <p>If the data entered for the rating matches the restriction, nothing will be saved, and this is the message that will be shown to the user.</p>

</div>
</div>
<div class='d2'>
<H2>  Display </H2>
<div class='d3'>
<H3>  Rating Page Display </H3>
             <p>You may opt to display: </p> 
             <ol>
             <li> In the bottom-left corner of the rating page, a box containing the total 
                  number of items to be rated, and the number of ratings currently saved by the judge</li>
             <li> At the top of the rating page, a button the judge may use to indicate that they have finished.
                  <b>NOTE:</b><i> The scheme setting for the display of this button may be overridden by setting the shortcode parameter "finish" to either "show" or "hide".</i><br><br>
                  When the judge clicks this, all visible items are checked to make sure no required fields have been left blank. 
                    Then, if everything is correct, 
                    <ul class="ewz_lpad"><li>The judge no longer has access to the page</li>
                        <li>The judge status in the Data Administration area shows "Finished", 
                            and a "Re-open for this judge" button appears.</li>
                    </ul>
                    Note that if there is no "required" field, the judge may click "Finished" at any time.  
                    In most cases, it would probably be a good idea to include at least one required field, 
                    even if it is simply a checkbox to indicate the item has been seen.        
               </li>
             </ol>
            <p>Main Table Colors:<br><br>
               The row referring to the image currently displayed in the image window is highlighted,
                    and unsaved rows get a border around them.<br> 
                This means that the <u>border and background color of the rows is controlled by javascript, not by your theme</u>.<br>  
                If the default color scheme ( white background with highlighted rows in light gray and unsaved rows bordered in black )
                does not work with your theme,  try changing the values at the bottom of this section.
            </p>

</div>
<div class='d3'>
<H3>  Large Image Display </H3>
          <h3>Please read this section carefully.</h3>
                <p>The main scoring window displays a thumbnail of each image, together with the inputs and information defined
                   in the rating scheme.  
                </p>
                <p> When the first thumbnail is clicked, a test image with maximum dimensions appears in a separate
                   browser window. This image window may need to be re-sized by the judge to make sure it is large enough to display
                    the test image ( and thus any of the images). Any subsequent click in a thumbnail displays the matching full-size
                    image in this same window.
                </p>
                <p>The two windows should be arranged side-by-side so that both are visible.</p>

          <hr>
          <p>Image resizing in browsers may not be as accurate as resizing by an image editing program like Photoshop, and may  
             introduce artefacts that are not present in the actual image. When applied to photographic-type images, browser
             "zooming" is also a form of resizing, with the same problems. 
             <br>Downloading a larger image and then scaling it down will also  waste bandwidth. 
          </p>
             
          <p>On the other hand, monitor sizes and pixel densities vary greatly. It is extremely difficult to judge an image that cannot fit  
             entirely into the screen, so a good deal  of care needs to be taken in deciding how large the uploaded image should be, 
             and what should be the requirements for the monitor used by the judge. 
          </p>

          <p>To accommodate the occasional judge with a screen somewhat smaller than the minimum, or a usage that does not require such
             an accurate display, as of Verson 1.1 you may optionally allow a limited amount of downsizing in the browser. 

          <hr>

          <p>To ensure that the image window can be large enough to show any of the images, you will need to set minimum pixel 
             dimensions for any monitor used for judging.
             The monitor dimensions would need to allow for <ul>
             <li>The operating system's window frame and title bar.</li>
             <li>A url bar at the top.</li>
             <li>Any padding you specify here for above the image.</li>
             <li>The image itself.</li>
             <li>The Next/Previous/Test Image links below the image.</li>
             </ul>
             Browsers and operating systems vary in how much space is taken up by the borders and headers, so the plugin comes with a generic 
             test image to help you check this. See the Path to Test Image help item.
          </p>

          <p>It's a tight fit, but if the maximum image dimensions are 1280x1024, a carefully-designed rating window with no sidebars
             can just be resized to fit beside the image window on a 1920x1200 monitor. ( Note 1920x1200 --  1920x1080 is too small ).
          </p>

          <hr>

          <p>The judge view was designed to be easily used with a dual monitor setup, where the image window is displayed on a good-quality,
             color-managed monitor, and the scoring window may be on a one of lesser quality.  Of course, both windows may also be displayed
             on a larger single monitor.</p>

          <p>For security reasons, browsers do not allow removal of the location bar in the image display.  To make sure
             the image is not too close to the ( usually white and visually distracting ) location bar, you can specify a minimum 
             amount of space above the image.  Dont forget to allow for this space and for the location bar itself when setting requirements
             for monitor sizes.
          </p>
          <p>If for some reason you need to have uploaded images that are too big to display like this, you may wish to move them to another 
             folder, and replace them in the ewz_img_uploads folder by downsized versions ( with exactly the same filenames ) for judging. 
          </p>

</div>
<div class='d3'>
<H3>  Test Image </H3>
             <p>To aid in checking required sizing of the image window, this plugin automatically generates a "test image" of maximum dimensions,
             which is displayed when the relevant button is clicked in the image window. (The images are stored in a folder "ewzr_test_images"  
             inside your wordpress uploads folder )</p> 
             <p>You may wish to replace this with your own test image, to assist in verifying color management as well as dimensions.
              ( A sample with dimensions 3600x2880 pixels is provided, which you would have to modify to suit your image size. )
             </p>
             <p> To do this, place your test image somewhere within your Wordpress uploads folder, and enter the
             path here. If your test image includes monitor test patterns, as the sample one does, you may wish to include instructions 
             for their use on the page above the shortcode. 
             </p>
             <p>For example, if you upload your test image to: </p>
             <pre>  your-base-directory/wp-content/uploads/my_site_images/1280x1024test.jpg</pre>
              <p>then in the box you would enter:</p>
             <pre>  my_site_images/1280x1024test.jpg</pre>
             <p><u>Your test image should have the exact dimensions you specify as the maximum, and have a border that is very clearly 
                visible against your choice of background color.</u></p>

</div>
<div class='d3'>
<H3>  Resizing </H3>
             <p>Earlier versions of Ewz-Rating did not allow for any resizing of the image in the browser. 
                To see the entire image, the judge needed to have a screen large enough to display the maximum image size.
             </p>
             <p>In version 1.1.0, to accommodate the increasing variety of monitor sizes and pixel densities, this restriction may optionally be relaxed.</p>
             <p>If you so select, the image may be scaled down proportionally in the browser, to a limit you specify. 
                ( Note that the limit is expressed as a percentage of the width (and height) of the image, not of its area. ).  
                Below that limit, scrollbars should appear as they did before, and a warning should show in the bottom right of the image window.
             </p> 
             <p>If the image is resized, the judge may toggle between the resized view and the full-size view with scrollbars.</p>
             <p>Note that for some, but not all, browsers, the "zoom" level set in the main scoring window may be carried over to the image window. 
                In some cases, this may soften the image, so judges who normally use a large zoom setting should be warned to set the zoom to 100% before 
                clicking the first thumbnail.  Unfortunately, this is beyond the control of Ewz-Rating. 
             </p>

</div>
</div>
<div class='d2'>
<H2>  Extra Data </H2>
           <p>In addition to the information entered by or displayed to judges, you may include several
            other items of information in the spreadsheet that you download.
           </p>
           <p>The source of the data is shown in parentheses. </p>
             <ul class="ewz_lpad"><li><b>"WP User data"</b> is information you control via the Wordpress Users menu. 
                     <u>Note that this data is only visible to admins with the right permission</u>.
                 </li>
                 <li><b>"EWZ Item data"</b> is information about an item stored by this plugin but not
                     actually set by the user.<br>
                     It may include data uploaded by the administrator via a .csv file
                     ( See the Data Management area on the WebForms page ).<br>
                     The WP Item ID is a numeric identifier created by Wordpress.  You will need this
                     if you wish to upload such a .csv file.
                 </li>
                 <li><b>"EWZ Webform data"</b> is mainly set by the administrator on the WebForms page. 
                     The WP Webform ID is a numeric identifier created by Wordpress.
                 </li>
                 <li><b>"Custom data"</b> is optional. Wordpress stores some information about a
                     user, but there are plugins, like CIMI User Extra Fields or S2Member,  that allow you
                     to add more information.<br>
                     If you have such a plugin, and if it provides a function to access the
                     information, you may tell EntryWizard about it -- see the "ewz-extra.txt"
                     file.
                 </li>
             </ul>
          

</div>
<div class='d2'>
<H2>  Add / Rearrange Schemes </H2>
          <p>To create a new scheme, you may either create a brand-new one ( no fields to start with ), or copy an existing one. 
             Either way, after creating the scheme you need to:</p>
              <ul class="ewz_lpad">
                  <li>Give it a name</li>
                  <li>Choose which data you wish displayed ( read-only ) on the rating form, and drag those items 
                      from the left-hand column to the "Fields to be displayed in Rating" area. 
                      ( An unsaved field created in this way may be dragged back to remove it. )</li>
                  <li>Click on the items to expand, and give them names and identifiers.</li>
                  <li>Add any fields you wish to have filled in by the judge by clicking the relevant buttons below 
                      the "Fields to be displayed in Rating" area.</li>
                  <li>Set the size and placement of the image</li>
                  <li>Choose any extra data you wish displayed in the downloaded spreadsheet</li>
                  <li>Save your changes</li>
                  <li>NOTE: As of version 1.1.1, when a scheme is created as a copy of another it is immediately saved on the server.
                      Then any restrictions are also copied automatically.
                  </li>
              </ul>
          
           <p> Rating Schemes may be dragged up or down to rearrange them. Clicking "Save Order of Schemes" will save the order, 
               and the new order will subsequently be used for this page and for the dropdown menus of rating schemes
               in the rating forms page
           </p>    

</div>
</div>
<br><hr class='ewzhelpdiv'>
<ul class="ewz_inline">
  <li class="ewzpagelink"><a class="" href="#helplayouts">Permissions</a></li>
  <li class="ewzpagelink"><a class="" href="#helplayouts">Layouts</a></li>
  <li class="ewzpagelink"><a class="" href="#helpwebforms">Webforms</a></li>
  <li class="ewzpagelink"><a class="" href="#helpitemlist">Webform Item List</a></li>
  <?php  do_action( 'ewz_before_help' ); ?>
</ul>
 <a id='helpratingforms' name='helpratingforms'></a>
 <hr class='ewzhelpdiv'>
<div class='d1'>
<H1>  Rating Forms </H1>
          <p>The EntryWizard "Rating" system is designed for viewing and/or judging the uploaded images. </p>
          <p>The Rating Form is generated by the 'ewz_rating' shortcode:  <b>&#91;ewz_show_rating&nbsp;&nbsp;identifier="xxx"&#93;</b>
         &nbsp; where xxx is the identifier you created for the rating form  
         ( note that there must be <u>no space beween the opening square bracket and the shortcode name</u> )</p>
         <p>NOTE 1: ewz_show_upload and ewz_show_rating shortcodes may <b>not</b> be mixed on the same page </p>
         <p>NOTE 2: Depending on your web hosting setup, there may be limitations on how much data a judge can save at one time. 
            Judges should be reminded to save frequently.  A Settings option allows for a popup reminder to do this. </p>
            <p>NOTE 3: Judges (and administrators) should always refresh the page after a period of inactivity, before doing any more work.</p>
             <p>-----------------</p>
          <p>A Rating Scheme describes the format of the rating form the way a layout describes the format of a WebForm, and each Rating Form must be assigned a previously-created Rating Scheme.
             Because it deals with the fields filled out when the image was uploaded, a rating scheme must be associated with a specific layout, and may only be used for items uploaded using that layout.</p>
          <p>Rating forms may be dragged to rearrange.  Click "Save Order of Rating Forms" to preserve the order for your next visit.</p>
             <p>The Rating Form is visible to, and editable by, anyone who has EntryWizard permissions to assign the layout associated with its Rating Scheme.  Downloading the spreadsheets requires permission to download from any webform with the associated layout, or permission to edit the rating form itself.</p>
             <p>In addition, as of version 1.1.4, permission to edit and download from any individual rating form may be set on the Permissions page.</p>
             <p>-----------------</p>
             <p>There are also some more parameters that may be added to the shortcode if you wish.  Here is the full list of parameters:
             <ul class="ewz_lpad"><li><b>identifier</b> e.g. identifier="competition2"  -- the identifier you created for the rating form.  
                     This parameter is required in all cases.</li>
             <li><b>item_ids</b> e.g. item_ids="256,278,300"  -- a comma-separated list of wordpress item_ids. 
                     If this parameter is present, only the listed items will be displayed. 
                     The easiest way to obtain the item_ids is to include "WP Item ID" in your spreadsheet, using the 
                     "Extra Data For Display in Spreadsheet" section of the Rating Scheme page.</li>
             <li><b>judge_ids</b> e.g. judge_ids="256,278,300" 
                  -- a comma-separated list of user_ids, which must be the Wordpress ID's of judges with access to the rating form.
                 If this parameter is present, judges <u>not</u> in the list will see nothing at all ( not even a "you do not have permission" message).
                 If it is not present, all judges specified in the rating form will be allowed to see the form. 
                 <br>Judge user_id's are shown in the judge selection box. </li>
             <li><b>rf_num</b>  e.g. rf_num="2" -- this parameter is <u>required if more than one ewz_show_rating
                  shortcode is present</u> on the page.<br>
                 Each shortcode must have a different rf_num parameter.</li>
             <li><b>view</b>   view="read", view="secondary" or view="rate"  -- specifies if the view is to allow input or just be "read-only".
                 "read" creates a totally read-only view. 
                  "secondary" creates a view where only fields with the "secondary" box checked may be changed, the rest are read-only. 
                  The default is "rate", which is the normal view showing all fields except those with the  "secondary" box checked. If there is no
                  "view" parameter, "rate" is assumed.<br>
                 The "divide between judges" field is ignored for the "read" view, but honoured for "rate" and "secondary" views.</li>
             <li><b>others</b> (Starting with version 1.1.3) Has only one possible value:  others="true".  
                 If this is set, ratings for all other judges will also be displayed (in read-only form). <br>
                 With 5 or fewer judges, a line will be displayed for each judge.  If there are more than 5 judges, only non-blank ratings will show.
                 <br><b>NOTE:</b>As of version 1.1.3, this parameter is required as well as 'view="read"' to obtain the view previously shown by 'view="read"'.</li>
             <li><b>finish</b> (Starting with version 1.1.9) finish="show" or finish="hide" controls whether the "finish" button is displayed to the judge.
                 If this parameter is not set, the default value from the rating scheme is used. </li>
            </ul>
              </p>
                 <p>When you edit a page (Visual tab), you should see a drop-down list of "EWZR" rating forms. 
                 Choose the "simple" option if you are just creating a single shortcode on  the page, with the normal "rate" view  and no 
                 limitations of items or judges beyond those set on the rating_form page.<br>  
                 For anything else, choose the "general" option and it will ask you for all the required inputs.
              </p>  
              <p><u>Always check the final page view</u>, just in case of errors in the shortcode, item selection, judge assignment, etc. 
                  
                 Since the person creating the rating form would not normally be a judge, it would be very useful to have a plugin installed
                 that allows an administrator to see the site as another user ( e.g. User Switching ). 
             </p>
             <p> &nbsp;
             </p>

<div class='d2'>
<H2>  Title </H2>
            <p>Each rating form needs a title which will be displayed at the top of the form.</p>

</div>
<div class='d2'>
<H2>  Identifier </H2>
                 <p>Each rating form also needs a short (no more than 15 characters) but unique identifier which is used in the shortcode. </p>
            <p>It must consist of letters, digits or underscores only ( no spaces ).</p> 
            <p>No two rating forms may have the same identifier.</p>
            

</div>
<div class='d2'>
<H2>  Item Selection </H2>
            <p>In this section, you select the items that  will be displayed in the rating form.  </p>
            <p>The items <b>must</b> have been uploaded via a webform using the <b>same layout</b> that was used for this rating form's scheme.</p>
            <p>All webforms using that scheme are listed here, and you are required to select one or more of them.
               You may optionally check "User's own images only". 
            </p>
            <p>Once the rating form has been saved, you will also be able to restrict the images to just items that 
               match any drop-down options associated with the <u>layout used for the image upload</u>.  
               ( You may find that using these options takes 
               more resources on the server. ) Currently only fields that are drop-down option lists are available here.
            </p>
            <p>Items will normally be displayed ordered by their wordpress item_id ( usually the order in which they were uploaded ).<br>
               This will often result in all or most of one person's images being shown consecutively.<br>
               If you check "Shuffle Item Order", a new number is generated from the item_id by "moving" the last digit to the start,
               and the items are sorted by this number. <br>This is not a random shuffling, but it does create a predictable order 
               that can be repeated if a judge refreshes a page.
            </p> 
            <p>It is inadvisable to change any of these settings once any judges have created ratings.</p>               

</div>
<div class='d2'>
<H2>  dq </H2>
           <p>Not everyone will need this. It allows you to flag some items as "disqualified", so that they remain in the entrywizard database, 
              but are <u>not shown to the judges</u>.  Potentially useful if you need to keep a record of such items.      
           </p>
           <p>Enter here the Item_ids of the disqualified items, separated by commas, like this: 1234,950,1235,1106</p>
           <p>The listed items will not be displayed to judges, but one line for each <u>will</u> appear in the downloaded spreadsheet.
              If you select to display the item_id's in the spreadsheet, those for disqualified items will be preceeded by 'DQ '.
           </p>

</div>
<div class='d2'>
<H2>  Access </H2>
            <p>Here you select who may see the rating form.  "All Logged-In Users" would not normally be 
               checked for a real "judging".  
               You would normally use it in combination with "Users Own Images" above, to show users a list of items they have uploaded. 
            </p>
            <p>Installing EntryWizard automatically creates a new Wordpress role 'EntryWizard Judge'. You may 
               select one or more users who have been assigned that role, and they will see all items matching the item selection above.
            </p>
            <p>Since the person creating the rating form would not normally be a judge, it would be very useful to have a plugin installed
               that allows an administrator to see the site as another user ( e.g. User Switching ). 
            </p>
            <p>If you wish to use already-registered users as judges, you may also find it helpful to install a plugin that lets you 
               give multiple roles to users. But if you do, be careful not to take away the 'EntryWizard Judge' role from an active judge.
            </p>
            <p>The "ID" values displayed in the judge selection box are the values assigned by Wordpress.  You may need them if you
                wish to create any "tie breaker" or other such forms limited to particular judges ( see the general Rating Form help 
               item at the top of this page ).
            </p>

</div>
<div class='d2'>
<H2>  Open </H2>
           <p>When this is checked, users with the right access will be able to see the rating form.  Otherwise 
              they will see just a message saying the form is not currently open.
           </p>

</div>
<div class='d2'>
<H2>  Data Management </H2>
           <p>When judges with "EntryWizard Judge" role have been selected, this area shows a summary of how many items 
              they have rated, and whether they have finished.</p>
           <p>When "All Logged-in Users" has been selected under Access Control, the area simply shows the total number of ratings saved by all users.
              This will be 0 if the form is for display only, and contains no input fields</p>
           <p>Because updating this puts a load on the server, what you see may not always be up-to-the-minute.  
              When you require exact information, click "Recalculate".
           </p>
           <p>You may, if necessary, delete all of a judge's ratings for this rating-form.</p>
           <p>You may also, if necessary, temporarily or permanently close the rating form for this judge only, by clicking "Force Finish". (This will cause the status to display as "Judge Finished", even if all items have not been judged.)</p>
           <p>If a judge has indicated they are finished, but you wish them to make further changes, click the "reopen" button 
                  to allow them access again.</p>

</div>
<div class='d2'>
<H2>  Overwrite </H2>
          <p>"Overwrite" options display only for fields that have been set to "secondary" in the rating scheme.</p>
          <p>They allow you to download a spreadsheet with values in, for instance, a "score" column overwritten by those in a secondary 
             "re-score" column if they exist for the same judge.</p>.

</div>
<div class='d2'>
<H2>  Download </H2>
           <p>When there is more than one judge, there are two possible formats for the downloaded spreadsheet.  
                  <ol><li><b>1 row per rating: </b>If there are 3 judges, each uploaded item will get 3 rows in the spreadsheet, one for each judge's inputs.</li>
                      <li><b>1 row per item: </b>There is only one row for each uploaded item, and extra columns are added for the judges' inputs.
                  To use this format, your rating scheme <u>must allow a blank column for each additional judge</u> immediately after each judge input column.<br>
                  For instance, if you have 3 judges, with each being asked for a score and a comment, the two columns right after your score column must be blank, 
                  and the two columns right after your comment column must be blank
                     </li>
                  </ol>
            </p>
            <p>With only one judge, the two formats should look the same. </p>
            <p>If the "divide" flag has been set for a field in the rating scheme, the id of the judge to whom it was displayed is shown in parentheses beside 
                  the field, or, if the judge has their own column, a star is shown beside the field. </p>
            <p>If "All Logged-in Users" has been selected under Access Control, only the "1 row per rating" format is available. </p>

</div>
<div class='d2'>
<H2>  Add / Arrange Rating Forms </H2>
                  <p>Add a New Rating Form creates a new Rating Form for the Rating Scheme you select 
                     ( provided there is at least one Webform associated with it ). You then need to:
              <ul class="ewz_lpad"><li>Give it a name and identifier</li>
                  <li>Select the WebForm(s) containing the items to be rated.</li>
                  <li>Select who is to be allowed access.</li>
                  <li>Check the "Open Rating" box when you are ready to allow rating.</li>
                  <li>Save your changes.</li>
                  <li>After saving, you may be able to refine your item selection, depending on the layout.</li>
              </ul>
           </p>
           <p> Rating Forms may be dragged up or down to rearrange them. Clicking "Save Order of Rating Forms" will save the order, 
               and the new order will subsequently be used for this page.
           </p>    

</div>
</div>
<br><hr class='ewzhelpdiv'>
<ul class="ewz_inline">
  <li class="ewzpagelink"><a class="" href="#helplayouts">Permissions</a></li>
  <li class="ewzpagelink"><a class="" href="#helplayouts">Layouts</a></li>
  <li class="ewzpagelink"><a class="" href="#helpwebforms">Webforms</a></li>
  <li class="ewzpagelink"><a class="" href="#helpitemlist">Webform Item List</a></li>
  <?php  do_action( 'ewz_before_help' ); ?>
</ul>
<?php
}

