"use strict";
jQuery(document).ready(function() {
    init_ewz_ratingforms();
});
jQuery(window).on("load", function() {
    do_ratingforms_setup();
});
var ewzG, ewzG1;
var popupN;  // used for id of popup 
var nNew;
var rforms_done = new Object();

/************************ The Ready and Load Functions  ****************************************/
/* generates the whole page from the ewzG structure */
/* called on ready */
function init_ewz_ratingforms(){
    fixConsole();
    popupN = 0;
    nNew = 0;

    // ewzG is null if not logged in
    if( null !== ewzG1 ){
        ewzG = ewzG1.gvar;
        if( ewzG.message ){
            ewz_alert(  'RF001', ewzG.message.replace(/~/g,"<br>"), ++popupN  );
        }
        for( var i = 0; i < ewzG.rating_forms.length; ++i){ 
            var rf_id = ewzG.rating_forms[i].rating_form_id.toString();
            // generate the form
            jQuery('#ewz_management').append(ewz_management_str(rf_id, ewzG.rating_forms[i], false));
        }
        jQuery('#ewz_management').append('<br>');
        jQuery('#ewz_management').after(rating_form_button_str());

        for (var rnum = 0; rnum < ewzG.rating_forms.length; ++rnum) {
            var rf_id = ewzG.rating_forms[rnum].rating_form_id;
            rforms_done[rf_id] = false;
        }
   }
}

/* called on load                                   */
function do_ratingforms_setup(){
        // make the ratingform postboxes sortable
        // ( "clone" option needed for firefox to stop opening on click )
        jQuery('#ewz_management').sortable({
            containment: 'parent',
            handle: ".ewz_hndle",
            items: "> div",
            distance: 5,
            helper: "clone"
        });
}


/************************ Functions Returning an HTML String ****************************************/

/* Returns the html string for a postbox containing a single rating form */
function ewz_management_str( rf_id, eObj, is_new ){
    var isclosed, str = '';
    if(!eObj){
        eObj= {};
    }
    
    isclosed = ' closed';
    if( eObj.rating_form_id == ewzG.openform_id ){
        isclosed = '';
    }
    str +='<div id="ewz_admin_ratingforms_ev' + rf_id + '_" class="metabox-holder">';
    str +=    '<div id="ewz-postbox-rating_form_ev' + rf_id + '_" class="ewz_box ' + isclosed + '">';
    str +=        '<input type="checkbox" name="self' + rf_id + '" id="self' + rf_id + '">';
    str +=        '<div  class="ewz_hndle" onClick="toggle_rform_box(this)" id="tpg_header_ev' + rf_id + '_"   >';
     str +=        '    <span class="ewz_indicator"></span>';
    str +=               '<div id="rf_title_' + rf_id + '">' + eObj.rating_form_title  + '</div>';
    str +=               '<div class="ewz_rstatus">' + (eObj.rating_open ? 'Open' :  'Closed') + ' &nbsp; ';
    str +=                    eObj.nratings + ' ratings</div>';
    str +=        '</div>';
    str +=        '<div class="inside">';

    str +=            '<div class="ewz_formsetup  ewz_scrollx">';
    str +=               '<div class="ewz_data">';
    str +=                  '<h4><u>Rating Scheme:</u> &nbsp; ' + eObj.rating_scheme.scheme_name;
    str +=                       '<br>';
    str +=                       '<u>For Images Uploaded Using Layout:</u> &nbsp; ' + eObj.rating_scheme.item_layout.layout_name;
    str +=                  '</h4>';

    str += rating_form_data_str(rf_id, eObj);
    str +=               '</div>';  


   if( !is_new ){
        str +=           '<div class="ewz_data">';
        str += data_management_str( rf_id, eObj );
        str +=           '</div>';   // end of ewz_data
    }

    str +=            '</div>';   // end of ewz_formsetup
    str +=        '</div>';       // end of inside
    str +=    '</div>';           // ewz-postbox-rating_form_ev
    str += '</div>';              // ewz_admin_ratingforms_ev
    return str;
}

function data_management_str( rf_id, eObj ){
    var str = '';
    str += '<h4><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'data\')"> &nbsp; Data Management</h4>';
    str += 'Counts below show only the number of images that have a rating for the judge. They are not affected by secondary views.<br>';
    str += 'The "finished" status reflects the most recently saved view of the rating form ( which may possibly be a secondary view ).<br> ';
    str += 'Click "Recalculate" to refresh the counts.<br> ';

    str += '<div class="ewz_status" id="ewz_status_' + eObj.rating_form_id  + '">';
    str +=        eObj.status_table;
    str += '</div>';

    str += '<button type="button" class="recalc" onClick=\'recalculate(this, ' + eObj.rating_form_id + ')\'>Recalculate</button>';
    str += '<div class="ewz_80"><p>For the "one row per item" spreadsheet format: </p>';
    str += '<p class="ewz_tab">This format is not suitable if "All Logged In Users" are allowed as judges.';
    str += '<br>If there is more than one judge, extra blank columns need to be allowed for in the rating scheme. ';
    str += '<br><u><b>Each column assigned to an item the judges fill out must be followed by N-1 blank columns</b></u>, where N is '; 
    str += 'the total number of judges.';
    str += '<br>Failure to do this will result in data with an invalid column assignment being surrounded by "*[ ... ]*" in the spreadsheet. </p></div>';
    
    if( eObj.can_download ){
        var overrides = '';
        for (var rfield_id in eObj.rating_scheme.fields) {
            if (eObj.rating_scheme.fields.hasOwnProperty(rfield_id) ){
                if( eObj.rating_scheme.fields[rfield_id].is_second ){
                    overrides += 'Overwrite column  <select name="overwrite[' + rfield_id + ']" id="overwr_' + rf_id +'_' + rfield_id + '"><option value="0,-1"></option>';
                    overrides += eObj.override_col_opts + "</select> with values from " + eObj.rating_scheme.fields[rfield_id].field_header + ".<br>";
                }
            }
        }
        
        str += '<form method="POST" action="" onsubmit="rform_add_nonce(this)" id="rdata_form_ev' + rf_id + '_">';
        str +=    '<div class="ewzform">';
        str +=       '<input type="hidden" name="ewzmode" value="rspread">';
        str +=       '<input type="hidden" name="rating_form_id" value="' + eObj.rating_form_id + '">';
        if( overrides ){
            str +=  '<img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'overwrite\')"> &nbsp; ';
            str +=  '<div style=" display: inline-block; border: 1px solid black; padding: 5px;">';        
            str +=  overrides;
            str +=    '</div><br><br>';
        }

        str +=        '<img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'download\')"> &nbsp; ';
        str +=       '<button type="submit" name="ss_style" value="I" id="spreadI_' + rf_id + '" class="button-secondary">';
        str +=                'Download Spreadsheet ( 1 row per item )</button>';
        str +=        ' &nbsp; &nbsp; ';

        str +=       '<button type="submit" name="ss_style" value="R" id="spreadR_' + rf_id + '" class="button-secondary">';
        str +=                'Download Spreadsheet ( 1 row per rating )</button>';
        str += '</div>';

       /* str +=    '<div class="ewz_numc">' + ewzG.nonce_string + '</div>'; */
        str += '</form>';
    }
    return str;
}


/* Return the html string for the editable data */
function rating_form_data_str(rf_id, eObj) {
    var str = '';
    var rs_id =  eObj.rating_scheme_id;

    str += '<form method="post" action="" id="rat_form_ev' + rf_id + '_">'; 
    str +=    '<div class="ewzform">';
    str +=       '<input type="hidden" name="rating_form_id" id="edit_rfid_' + rf_id + '" value="' + rf_id + '">';
    str +=       '<input type="hidden" name="rating_scheme_id" id="edit_rsid_' + rf_id + '" value="' + rs_id + '">';
    str +=       '<input type="hidden" name="ewzmode" value="ratingform">';

    str +=       '<table class="ewz_rating_padded">';
    str +=          '<tr><td><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'title\')">&nbsp;Title:</td>';
    str +=             '<td>' + textinput_str('ewz_rform_title_ev' + rf_id + '_', 'rating_form_title', 50, eObj.rating_form_title) + '</td>';
    str +=          '</tr>';
    str +=          '<tr><td><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'ident\')">&nbsp;Identifier:</td>';
    str +=              '<td>' + textinput_str('rating_form_ident_ev' + rf_id + '_', 'rating_form_ident', 15, eObj.rating_form_ident) + '</td>';
    str +=          '</tr>';

    str += item_selection_str( rf_id, eObj );
    str += hide_items_str( rf_id, eObj );
    str +=         '<tr><td><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'access\')">&nbsp;Access Control<br>(Judges):</td>';
    str +=             '<td class="ewz_shade">';
    str +=                 '<i>To be listed here, judges need to be assigned the role "EntryWizard Judge",<br> which is automatically created by EntryWizard</i>';
    str +=                 '<select multiple="multiple" name="judges[]" id="judges' + rf_id + '"  size="8" >';
    str +=                    eObj.userlist;
    str +=                 '</select>'; 
    str +=                  '<div class="ewz_judgelist"><u>Judges with login names:</u> <br>' + eObj.judgelist + '</div>';
    str +=                     eObj.badJudgeMsg;
    str +=              '</td>';
    str +=         '</tr>';
    str +=         '<tr><td><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'open\')">&nbsp;Open Rating:</td>';
    str +=             '<td>' + checkboxinput_str('rating_open' + rf_id + '_', 'rating_open', eObj.rating_open ) + '</td>';
    str +=         '</tr>';
    str +=       '</table>';

   /* str +=      '<div class="ewz_numc">' + ewzG.nonce_string + '</div>';*/
    str +=      '<p>';
    str +=      '<button id="rat_form_wf' + rf_id + '_" type="button" class="button-primary" ';
    str +=              'onClick="ewz_check_rform_input( '  + "'" + rf_id +  "'" +  ', ' + ewzG.jsvalid  + ' )" >';

    str +=      'Save Changes</button> &nbsp;  &nbsp;  &nbsp;  &nbsp; ';
    str +=     '<button type="button" id="rfdel_' + rf_id + '_" class="button-secondary"';
    str +=             'onClick="delete_rating_form( this, ' + eObj.nratings + ')">Delete Rating Form</button>';
    str +=      '</p>';
    str +=  '</div>';
    str += '</form>';
    return str;

}

function hide_items_str( rf_id, eObj ){
    var dqlist = typeof( eObj.item_selection.dq_items ) === 'undefined' ? '' : eObj.item_selection.dq_items.join();
    var str = '<tr id="items_dq' + rf_id + '">';
    str +=      '<td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'dq\')">&nbsp;Disqualified Items:</td>';

    str +=      '<td colspan="2">' + textinput_str('dq_items' + rf_id + '_', 'dq_items', 500, dqlist ) + '</td>';
    str +=  '</tr>';
    return str;
}

function item_selection_str( rf_id, eObj ){

    var own = false, newinfo = '', str = '';

    if( eObj.item_selection !== undefined ){
        own = eObj.item_selection.own;
    }
   if( String(rf_id).substring( 0, 1) == 'X' ){
        newinfo = '<br><i>More options will be available<br>after saving the rating form</i>';
    }
    str += '<tr id="item_sel' + rf_id + '">';
    str +=      '<td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'iselect\')">&nbsp;Item Selection:' + newinfo + '</td>';

    var i = js_find_by_key(ewzG.rating_forms, 'rating_form_id', rf_id );
    str +=  '<td class="ewz_shade">';
    if( undefined !== ewzG.rating_forms[i] ){
        str +=     '<div class="item_sel">';
        if( eObj.layout_err ){
            str += '<div class="ewz_warn">';
            str +=     eObj.layout_err + "<br>";
            str += '</div>';
        }
        str +=         'Webform(s):<br>' + webform_selection_str( eObj.rating_scheme.item_layout_id, i, rf_id );
        str +=     '</div>';
    }
    str +=     '<div  class="item_sel">';
    str +=         '<label class="item_sel" >Shuffle Item Order: '+ checkboxinput_str('shuffle_' + rf_id + '_', 'shuffle', eObj.shuffle ) + '</label>';
    str +=         '<label class="item_sel">User&#39;s Own Images Only: ' + checkboxinput_str("own" + rf_id, "own", own ) + '</label>';
    str +=     '</div>';
    if( eObj.hasOwnProperty('field_options' ) ){
        str +=  field_selection_str( eObj );
    }
    str += '</td></tr>';

    return str;
}

/* Display all webforms with layout_id equal to item_layout_id */
function webform_selection_str( item_layout_id, i, rf_id ){
    var wfm, str ='', sel = '';
    str += '<select class="ewz_field_sel" multiple="multiple" name="webform_ids[]" id="webform_ids' + rf_id + '">';
    for( wfm in ewzG.webforms ){
        sel = '';
        var is_sel = ( jQuery.inArray( String( ewzG.webforms[wfm].webform_id ), ewzG.rating_forms[i].item_selection.webform_ids ) > -1 );
        if(  (ewzG.webforms[wfm].layout_id == item_layout_id) || is_sel ){
            var open = '';
            if( ewzG.webforms[wfm].hasOwnProperty('open') ){
                if( ewzG.webforms[wfm].open || ewzG.webforms[wfm].open_for.length > 0 ){
                    open = ' ** OPEN for Upload';
                }
            }
            if( is_sel ){
               sel =  ' selected="selected"';
            }
            str += '<option value="' + ewzG.webforms[wfm].webform_id + '"' + sel + '>' + ewzG.webforms[wfm].webform_title + open + '</option>';
        }
    }
    str += '</select>';
    return str;
}


/* Return the html string for the field boxes for selecting items */
function field_selection_str( eObj ){
    var field_id1, field_id2, fid, str ='';
    if( eObj.hasOwnProperty('field_options') ){
        // selection boxes
        for( field_id2 in eObj.field_options ){
           if(eObj.field_options.hasOwnProperty(field_id2)){
               if( eObj.field_options[field_id2] ){
                   str +=  '<div  class="item_sel">';
                   str +=          eObj.field_names[field_id2] + '<br>';  
                   str +=         '<select class="ewz_field_sel" multiple="multiple"  name="fopt[' + field_id2 +'][]"  id="l'+ eObj.rating_form_id + 'f' + field_id2 + '_opt_">';
                   str +=               eObj.field_options[field_id2];
                   str +=         '</select>';
                   str +=  '</div>';
               }
           }
        }
    }
    return str;
}

function rating_form_button_str(){
    var str = '';
    str += '<div class="clear alignleft">';
    str +=    '<img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'rfsort\')"> &nbsp;';
    str +=    '<button  type="button" class="button-secondary" id="rating_form_add_" onClick="add_new_rating_form()">Add a New Rating Form</button> ';
    str +=    'for rating-scheme ';
    str +=    '<select id="rating_scheme_id">' +  ewzG.schemes_list + '</select> <span class="ewz_space50"></span>';
    str +=    '<button type="button" class="button-secondary" id="rating_forms_save2_" onClick="save_ratingform_order()"> Save Order of Rating Forms </button> ';
    str += '</div> ';
    return str;
}

/************************ Batch Functions  ****************************************/

function do_batch(){
    var the_nonce = jQuery('#ewznonce').val();
    var formlist = [];
    var titlelist =  '<br>';
    jQuery('#ewz_management').find('input[id^="self"]:checked').each(function() {
        var id = jQuery(this).attr('id').replace('self','');
        formlist.push( id );     
        titlelist += ( '<br>* ' + jQuery('#rf_title_' + id).text() );
    });
   
    var action = jQuery('#bulk-action-selector').val();
    switch( action ){
        case 'ewz_batch_delete_rforms':
        ewz_confirm( "Are you sure you want to delete all these rating forms and their associated ratings? " + 
                             titlelist + "<br><br>This action cannot be undone.",
                     function(){ batch_action( action, formlist, the_nonce ); },
                     null,
                     ++popupN); 
        break;
        case 'ewz_batch_delete_ratings':
        ewz_confirm( "Are you sure you want to delete all the ratings from these rating forms?  " + 
                             titlelist + "<br><br>This action cannot be undone.",
                     function(){ batch_action( action, formlist, the_nonce ); },
                     null,
                     ++popupN); 
        break;
    }
}

function batch_action( action_type, formlist, the_nonce ){
    var target = '';
    switch( action_type ){
    case 'ewz_batch_delete_rforms':
        target = 'forms';
        break;
    case 'ewz_batch_delete_ratings':
        target = 'ratings';
        break;
    }
    // ajaxurl variable is actually available in admin, do not need ewzG for it
   var jqxhr = jQuery.post( ewzG.ajaxurl,
                             {
                               ewzmode: 'rf_set',
                               action: 'ewz_forms_batch_delete',
                               target: target,
                               rating_form_ids: formlist,
                               ewznonce: the_nonce
                             },
                             function (response) {
                                 ewz_alert( 'RF013', response, ++popupN).on("dialogclose", 
                                                                             function(){
                                                                                 document.location.reload(true);
                                                                             }
                                                                           );
                              }
                            ).fail( function( jqXHr, textStatus, errorThrown ){ 
                                ewz_alert( 'RF014', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );
                            } );
}

function save_ratingform_order(){
    var rf_nonce = jQuery('#ewznonce').val();
    var data = {
        action: 'ewz_save_rating_form_order',
        ewznonce:   rf_nonce,
        ewzmode:  'rf_set',
        rforder: new Object()
    };
    if( jQuery('input[id^="edit_rfid"][value=""]').length > 0 ){
        // a new rating form has not yet been saved
        ewz_alert("RF004", "Please save your unsaved Rating Forms before trying to rearrange them", ++popupN);
       return;
    }
        
    jQuery('input[id^="edit_rfid"]').each(function(index){
        data['rforder'][jQuery(this).val()] = index;
    });
    data['action'] = 'ewz_save_rating_form_order';
    data['ewznonce'] = rf_nonce;
    var jqxhr = jQuery.post( ewzG.ajaxurl,
                         data,
                         function (response) {
                             jQuery("#temp_del").remove();
                                 ewz_alert( 'RF005', response, ++popupN );
                         }
                       ).fail( function(jqXHr, textStatus, errorThrown){ 
                           ewz_alert( 'RF011', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );       
}

function toggle_select_all_forms(){
    if( jQuery('#ewz_all_forms').prop('checked') ){
        jQuery('input[id^="self"]').prop('checked', true );
    } else {
        jQuery('input[id^="self"]').prop('checked', false );
    }  
}   

function sort_alpha(){
    var mylist = jQuery('#ewz_management');
    var listitems = mylist.children('div').get();
    listitems.sort(function(a, b) {
        var ja = jQuery(a);
        var jb = jQuery(b);
        var ta = jQuery('#' + ja.attr('id').replace('ewz_postbox_webform_ev', 'wf_title') ).text();
        var tb = jQuery('#' + jb.attr('id').replace('ewz_postbox_webform_ev', 'wf_title') ).text();
        return (ta < tb) ? -1 : (ta > tb) ? 1 : 0;
    });        
    jQuery.each(listitems, function(idx, itm) {
        mylist.append(itm);
    });
}

/************************ Individual Rating Form Setup Functions  ****************************************/

function toggle_rform_box( handle){
    var rf_id = get_rform_ident( handle );
    var jhndle = jQuery(handle);
    jhndle.closest('.ewz_box').children(".inside").toggle();

    if( !rforms_done[rf_id] ){
        setup_rating_form( rf_id );
        rforms_done[rf_id] = true;
    }
    jhndle.toggleClass('ewz_hndle');
    jhndle.children('span.ewz_indicator').first().toggleClass('ewz_open');
}

function setup_rating_form( rf_id ){
    var jForm = jQuery('#ewz_admin_ratingforms_ev' + rf_id + '_');

    // add onChange function  
    jQuery('#ewz_rform_title_ev' + rf_id + '_').on("change", function(){
        var jthis = jQuery(this);
        jthis.closest('div[id^="ewz-postbox-rating_form_ev"]').find('div[id^="rf_title_"]').text(jthis.val());
    });
    jQuery('#ewz_rform_title_ev' + rf_id + '_').on("keyup",function(){
        var jthis = jQuery(this);
        jthis.closest('div[id^="ewz-postbox-rating_form_ev"]').find('div[id^="rf_title_"]').text(jthis.val());
    });

    jForm.find('select[id^="judges"]').multiSelect({ keepOrder: true, 
                                                     selectionHeader: 'Selected Judges:',  
                                                    selectableHeader: 'Click to select:'});

}

function get_rform_ident(element) {
    var id = jQuery(element).closest('div[id^="ewz_admin_ratingforms_ev"]').attr('id');
    return id.replace('ewz_admin_ratingforms_ev','').replace('_','');
}

/************************ Individual Rating Form Add and Delete Functions  ****************************************/

/* Actually delete the form on the server via ajax.  If successful, delete it from the page. */
function delete_rating_form( button, ratingcount ){
    var jbtn = jQuery(button);
    var formdiv = jbtn.closest('div[id^="ewz_admin_ratingforms_ev"]');
    var fid = formdiv.find('input[name="rating_form_id"]').first().attr("value");
    if( '' === fid || null === fid || undefined ===  fid ){
        formdiv.remove();
        return;
    }
    var confirmstring = '';
    if( ( ratingcount !== undefined ) && ( ratingcount > 0 ) ){
       confirmstring +=  ewzG.errmsg.warn + "<br>"  + ewzG.errmsg.hasitems + "\n\n";
    }
    confirmstring += ewzG.errmsg.reallydelete;
    confirmstring += "<br>" + ewzG.errmsg.noundo;

    ewz_confirm( confirmstring,
                 function(){ 
                     do_wipe_rform( jbtn, formdiv, fid ); 
                 },
                 null, ++popupN );
}

function do_wipe_rform( jbtn, formdiv, fid ){
    try{
         var fname = jbtn.closest('div[id^="ewz-postbox-rating_form_ev"]').find('div[id^="rf_title_"]').text();
         var d_nonce = jQuery('#ewznonce').val();
         jbtn.after('<span id="temp_del" style="text-align:left">Processing, please wait ... <img alt="Please Wait" src="' + ewzG.load_gif + '"/></span>');
        var except;
        // ajaxurl variable is actually available in admin, do not need ewzG for it
         var jqxhr = jQuery.post( ewzG.ajaxurl,
                              {
                                  action: 'ewz_delete_rform',
                                  rating_form_id: fid,
                                  rating_form_title: fname,
                                  ewznonce: d_nonce
                              },
                              function (response) {
                                  jQuery("#temp_del").remove();
                                  if( '1' == response ){
                                      formdiv.remove();
                                      var index = js_find_by_key(ewzG.rating_forms, 'rating_form_id', fid);   
                                      ewzG.rating_forms.splice(index, 1);                                     
                                  } else {
                                      ewz_alert( 'RF006', response, ++popupN );
                                  }
                              }
                            ).fail( function(jqXHr, textStatus, errorThrown){ 
                                ewz_alert( 'RF012', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );  
    } catch(except){
        console.log("Problem in ewz_delete_rform: " +   except.message );  // needed for admin
    }
}

function add_new_rating_form(){
    var jQnew, newid,
        num = ewzG.rating_forms.length,
        newform = {};
    ++nNew;

    newform.can_manage_rating_form = true;
    newform.nratings = 0;
    newform.item_selection = {};
    newform.rating_open = false;
    newform.rating_scheme = ewzG.schemes[jQuery('#rating_scheme_id').val()];
    newform.rating_scheme_id = jQuery('#rating_scheme_id').val();
    newform.rating_form_title = '';
    newform.rating_form_id = '';
    newform.rating_form_ident = '';
    newform.userlist = ewzG.userlist;
    ewzG.rating_forms[num] = {};
    ewzG.rating_forms[num]['item_selection']={};
    ewzG.rating_forms[num]['item_selection']['webform_ids'] = ewzG.webforms;
    newid = 'X'+nNew;
    ewzG.rating_forms[num]['rating_form_id'] =  newid;
    jQnew = jQuery(ewz_management_str( newid, newform, true));
    if( jQnew.find('select[id^="webform_ids"] option').length < 1 ){
        ewz_alert( "RF002", "You cannot create a Rating Form without at least one webform.  No Webforms have been created using this layout.", ++popupN );
        return;
    }
    jQnew.find('div[id^="rf_title_"]').first().html("New Rating Form: <i>To make it permanent, set the options and save</i>");
    jQnew.find('input[name="rating_form_id"]').val('');
    setup_rating_form( newid );

    jQuery('#ewz_management').append(jQnew);
}


/************************ Individual Rating Form Check and Save Functions  ****************************************/

function ewz_check_rform_input( rf_id, do_js_check){
    var jform = jQuery('#rat_form_ev' + rf_id + '_');
    var evnum = js_find_by_key( ewzG.rating_forms, 'rating_form_id', rf_id ); 
    if( do_js_check) {
        // disable the submit button
        jQuery('#rat_form_wf' + rf_id + '_').prop("disabled", true);
        var except;
        try{
            // must have a title
            var jtitle = jform.find('input[id^="ewz_rform_title_ev"]');
            if( !(jtitle.val() && jtitle.val().trim()) ){
                err_alert(rf_id, ewzG.errmsg.formTitle);
                return false;
            }
            // must have an ident of the right form
            var jident = jform.find('input[id^="rating_form_ident_ev"]');
            if( !( jident.val() && jident.val().match(/^[a-z0-9_\-]+$/i)) ){
                err_alert(rf_id, ewzG.errmsg.formIdent);
                return false;
            }
            // must have at least one judge if rating open
            var selj = jform.find('select[id^="judges"]');
            if( ( selj.val() === undefined ) ||  ( selj.val() == null ) ){
                if( jform.find('input:checked[id^="rating_open"]').length > 0 ) {
                    err_alert( rf_id, ewzG.errmsg.judge );
                    return false;
                }
            }
            // must have at least one webform
            var selwf = jform.find('select[id^="webform_ids"]');
            if( ( selwf.val() === undefined ) ||  ( selwf.val() == null )){
                err_alert(rf_id, ewzG.errmsg.webform);
                return false;
            }
        } catch(except) {
            jQuery('#rat_form_wf' + rf_id + '_').prop("disabled", false);
            err_alert( rf_id, "Sorry, there was an unexpected error: " + except.message);
            return false;
        }
    }
    if( rf_id.toString().substring(0, 1 ) == 'X' ){
        do_submit( jform, rf_id, evnum );
    } else {
        var form = ewzG.rating_forms[evnum];
        var msg = '';

        // warn if rating form is open and  any webform is open for upload
        if( jform.find('input:checked[id^="rating_open"]').length > 0 ){
            var selwf = jform.find('select[id^="webform_ids"]');
            selwf.find( 'option:selected:contains("** OPEN for Upload")').each(function() {
                msg += "A webform selected here is currently open for upload. Users will get an error message if they attempt to delete an item that has a rating."; 
                return;
                } );
        }
             
        if( form.rating_open || ( form.curr_total > 0 ) ){
            var old_judges = form.str_judges;
            var new_judges = jQuery('#ewz_admin_ratingforms_ev' + form.rating_form_id + '_').find('select[id^="judges"]').val();
            var added_judges = jQuery(new_judges).not(old_judges).get();
            var removed_judges = jQuery(old_judges).not(new_judges).get();
            if( form.divide_a_field && ( added_judges.length > 0  || removed_judges.length > 0 ) ){
                msg += "<br>The judge selection has been changed, and there is a field divided between the judges. ";
                msg += "Assignment of this field to the judges will change.<br>";
            }
            for( var i=0; i<removed_judges.length; i++) {
                if( form.rating_status[removed_judges[i]] > 0 ){
                     msg += "<br>A judge with existing ratings is being removed. Those ratings will no longer be displayed in the spreadsheet.<br>";
                    break;
                }
            }
            // an option originally selected is not selected now, and "any" is not selected, so items may have been removed from the selection
            jQuery('#item_sel' + rf_id ).find('option[selected="selected"]').not(":selected").each(function(index){
                 if( jQuery(this ).closest('select').val() != '~*~' ){
                     msg += "<br>You have changed the selection of items.<br><br>";
                     msg += "Removing items from the selection will mean that any existing ratings for them will not appear in the spreadsheet. ";
                     msg += "<br><br>If there are existing ratings, their counts will still show on the rating page, ";
                     msg += "even though the items themselves will no longer display.";
                 } 
            });
            var jown = jQuery('#own' + rf_id);
            if( jown.prop( "checked" ) && ( !jown.prop( 'defaultChecked' ) ) ){
                msg += "<br>Restriction to judges' own items has been added. This means that some already-existing ratings may not appear in the spreadsheet";
            } 
        }

        if( msg ){
           ewz_confirm("Are you quite sure?<br>" + msg, 
                       function(){ do_submit( jform, rf_id, evnum ); }, 
                       function(){ jQuery('#rat_form_wf' + rf_id + '_').prop("disabled", false); }, 
                       ++popupN );
        } else {
           do_submit( jform, rf_id, evnum );
        }       
    }    
 }

function do_submit( jform, rf_id, evnum ){
    var except2;
    jform.append('<input type="hidden" name="action" value="ewz_rform_changes" />');
    jform.append('<input type="hidden" name="ewznonce" value="' + jQuery('#ewznonce').val() + '">');
    try{
        // ajaxurl variable is available in admin
        jQuery.post(ajaxurl,
                    jform.serialize(),
                    function(response) {
                        if( response.success ){
                            var new_rf_id = response.data.rating_form_id;
                            ewzG.rating_forms[evnum] = response.data;
                            var newstr = ewz_management_str( new_rf_id, response.data, false );
                            jQuery('#ewz_admin_ratingforms_ev' + rf_id + '_').replaceWith( newstr );
                            
                            setup_rating_form( new_rf_id );
                            rforms_done[new_rf_id] = true;
                            var loc = jQuery('#ewz_admin_ratingforms_ev' + new_rf_id + '_').position().top - 50;
                            jQuery('html, body').scrollTop( loc );
                            ewz_alert('RF007', 'Saved Rating Form "' + response.data.rating_form_title + '"', ++popupN );

                        } else {
                            ewz_alert( 'RF015', response.data, ++popupN);
                        }
                    }).fail( function( jqXHr, textStatus, errorThrown ) { ewz_alert( 'RF016', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );

    } catch (except2) {
        ewz_alert("RF017", "Sorry, there was an unexpected error: " + except2.message, ++popupN);
        return true;   // should make regular submit work
    }
}

function rform_add_nonce( download_form ){
    jQuery(download_form).append('<input type="hidden" name="ewznonce" value="' + jQuery('#ewznonce').val() + '">');
}


function err_alert(rf_id, msg){
    jQuery('#rat_form_wf' +  rf_id + '_').prop("disabled", false);
    ewz_alert('RF003', msg, ++popupN);
}


/************************ Individual Rating Form Data Management Functions  ****************************************/

function del_judge_ratings( judge_id, rf_id ){
    var judge_name = jQuery('#jname_' + rf_id + '_' + judge_id).text();
    ewz_confirm("Really remove ALL ratings from this form for judge " + judge_name + "?  This action cannot be undone.",
               function(){ 
                  do_del_judge_ratings( judge_id, rf_id );
               }, 
               null, ++popupN );
}      

function do_del_judge_ratings( judge_id, rf_id ){
    var the_nonce = jQuery('#ewznonce').val();
    // ajaxurl variable is actually available in admin, do not need ewzG for it
    var jqxhr = jQuery.post( ewzG.ajaxurl,
                             {
                               action:  'ewz_del_judge_ratings',
                               judge_id: judge_id,
                               rating_form_id: rf_id,
                               ewznonce: the_nonce
                             },
                             function (response) {
                                 jQuery('#ewz_status_' + rf_id).fadeOut(100).fadeIn(100);
                                 jQuery('#ewz_status_' + rf_id).html( response );
                              }
                            ).fail( function(jqXHr, textStatus, errorThrown){ 
                                ewz_alert( 'RF008', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );
}      

function close_for_judge(judge_id, rf_id){
     var judge_name = jQuery('#jname_' + rf_id + '_' + judge_id).text();
    ewz_confirm("Really close the rating for for judge " + judge_name + "?",
                function(){ 
                    do_judge_close( judge_id, rf_id );
                },
                null, ++popupN );
}
   
function do_judge_close( judge_id, rf_id ){ 
    var the_nonce = jQuery('#ewznonce').val();
    // ajaxurl variable is actually available in admin, do not need ewzG for it
    var jqxhr = jQuery.post( ewzG.ajaxurl,
                             {
                               action:   'ewz_judge_close',
                               judge_id: judge_id,
                               rating_form_id: rf_id,
                               ewznonce: the_nonce
                             },
                             function (response) {
                                 jQuery('#ewz_status_' + rf_id).fadeOut(100).fadeIn(100);
                                 jQuery('#ewz_status_' + rf_id).html( response );
                              }
                            ).fail( function(jqXHr, textStatus, errorThrown){ 
                                ewz_alert( 'RF009', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );       
}

function judge_reopen( judge_id, rf_id ){ 
    var judge_name = jQuery('#jname_' + rf_id + '_' + judge_id).text();
    ewz_confirm("Really allow judge " + judge_name + " to edit ratings again?",
                function(){ 
                    do_judge_reopen( judge_id, rf_id );
                },
                null, ++popupN );
}

function do_judge_reopen( judge_id, rf_id ){ 
    var the_nonce = jQuery('#ewznonce').val();
    // ajaxurl variable is actually available in admin, do not need ewzG for it
    var jqxhr = jQuery.post( ewzG.ajaxurl,
                             {
                               action:   'ewz_reopen',
                               judge_id: judge_id,
                               rating_form_id: rf_id,
                               ewznonce: the_nonce
                             },
                             function (response) {
                                 jQuery('#ewz_status_' + rf_id).fadeOut(100).fadeIn(100);
                                 jQuery('#ewz_status_' + rf_id).html( response );
                              }
                            ).fail( function(jqXHr, textStatus, errorThrown){ 
                                ewz_alert( 'RF018', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );       
}



function recalculate( button, rating_form_id ){
    var rf_nonce = jQuery('#ewznonce').val();
    jQuery(button).prop("disabled", true);
    // ajaxurl variable is actually available in admin, do not need ewzG for it
    var jqxhr = jQuery.post( ewzG.ajaxurl,
                             {
                                 action: 'ewz_recalc',
                                 ewznonce:   rf_nonce,
                                 rating_form_id: rating_form_id
                             },        
                             function(response) { 
                                 jQuery('#ewz_status_' + rating_form_id).fadeOut(100).fadeIn(100);
                                 jQuery('#ewz_status_' + rating_form_id).html(response);
                                 jQuery(button).prop("disabled", false);

                             }
                          ).fail( function(jqXHr, textStatus, errorThrown){ 
                              ewz_alert( 'RF010', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );        
}


