'use strict';
/* ewzalrt RS014 */

jQuery(document).ready(function() {
    init_ewz_schemes();
});
jQuery(window).on("load", function() {
    do_scheme_setup();
});

var ajaxurl;    // ajaxurl variable is available in admin

var ewzG, ewzG1;  
var newfieldN;  // number of latest added field
var newschemeN;  // number of latest added scheme
var popupN;  // used for id of popup 
var g_changesMade, g_doingSubmit;
var schemes_done = new Object();

function ewz_added_spread_note(){
    return '<br><b>Reminder: </b>If you use the "1 row per item" spreadsheet format, and have more than one judge, each column of type "Input Field" must be followed by one blank column per extra judge.';
}

/************************ The OnLoad Function  ****************************************/
/* called on load                                   */
/* generates the whole page from the ewzG structure */
function init_ewz_schemes() {
    fixConsole();
    newfieldN = 0;
    g_changesMade = false;
    g_doingSubmit = false;

    popupN = 0;
    newschemeN = 0;
    // ewzG is null if not logged in
    if (null !== ewzG1) {
        ewzG = ewzG1.gvar;
       if( ewzG.do_warn ){ 
           window.addEventListener("beforeunload", function (e) {
                if( g_changesMade && !g_doingSubmit ){
                    var confirmationMessage = "Really leave this page? Changes you made may not be saved.";
                    (e || window.event).returnValue = confirmationMessage; //Gecko + IE
                    return confirmationMessage;                            //Webkit, Safari, Chrome
                }
           });
        }
        // console.log(ewzG);
        for (var snum = 0; snum < ewzG.schemes.length; ++snum) {
            // error message, page titles, fields
            var sid = ewzG.schemes[snum].rating_scheme_id;
            jQuery('#ewz_schemes').append(scheme_str( sid, ewzG.schemes[snum]));
            var sid = ewzG.schemes[snum].rating_scheme_id;
            schemes_done[sid] = false; 
        }
        if (ewzG.message) {
            ewz_alert('RS001', ewzG.message, ++popupN); 
        }
        jQuery('#ewz_schemes').after(add_scheme_button_str());
    }
}

function do_scheme_setup(){
    // ( "clone" option needed for firefox to stop opening on drag-drop )
    jQuery('#ewz_schemes').sortable({
        containment: 'parent',
         handle: ".ewz_shndle",
        helper: "clone"
    });  
}


/* Variance makes no sense in EntryWizard, only in Rating, but the code for an  */
/* option list comes from EntryWizard.   So we tack the variance code on here. */
function add_variance(scheme_id){ 
    function getscheme(scheme){
        return scheme.rating_scheme_id == scheme_id;
    }
    if( !isNaN(scheme_id)  ){
        
        jQuery('#ewz_admin_schemes_f' + scheme_id + '_').find('button[id$="_optset_"]').each(function(){
            var joptset = jQuery(this);
            if(joptset.closest('td[id^="special_"]').find('select[id$="_variance"]').length == 0 ){
                var bits = joptset.attr("id").split('_');        
                var field_id = bits[1].replace('fields','');
                var column = ewzG.schemes.filter( getscheme)[0].fields[field_id]['fdata'].ss_var_col;
                if( undefined === column ){
                    column = "-1";
                }
                add_variance_to_field(scheme_id, field_id, column);
            }
        });
    }                                                                                        
}

function add_variance_to_field(scheme_id, field_id, column){
    var optset_id = '#sch' + scheme_id + '_fields' + field_id + '_optset_';
    var joptset = jQuery(optset_id);
    var onch = 'disable_ss_options(' + "'.ssc" + scheme_id + "'" + ')';

    var newid = 'sch' + scheme_id + '_fields' + field_id + '_sscol_variance';
    var jss_select = joptset.closest('table[class="ewz_rfield"]').find('select[id$="_ss_column_"]');

    var sel_str = '<br><br><table><tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'variance\')">';
    sel_str += 'Spreadsheet Column for Variance: &nbsp; &nbsp; </td>';
    sel_str += '<td><select id="' + newid + '" name="fields[' + field_id + '][fdata][ss_var_col]"  class="ssc' + scheme_id + '" onchange="' + onch + '" >';
    sel_str += jss_select.html().replace('selected="selected"','') + '</select></td></tr></table>';
    if(joptset.closest('td[id^="special_"]').find('select[id$="_variance"]').length == 0 ){
        joptset.after( sel_str  );
        jQuery('#' + newid).find('option[value=' + column + ']').attr("selected","selected");
    }
}



function set_drag_drop(sid){

    var rfields = '#ewz_sortable_rfields' + sid;
    var lfields = '#ewz_layout_fields' + sid;

    // ( "clone" option needed for firefox to stop opening on drag-drop )

    jQuery(lfields ).sortable({
        connectWith: rfields,
        helper: "clone",
         receive: function(event, ui ){
            if( ui.item.attr("id").indexOf('_fieldsX') == -1 ) {
                ui.sender.sortable("cancel");
            } else {
                ui.item.find('span.ewz_indicator').hide();
            }
         },
         stop: function(event, ui ){
             if( ( ui.sender == null || ui.sender === undefined ) && ui.item.parent().attr("id").match(/^ewz_layout_fields/)){
                   jQuery(this).sortable("cancel");
             }}
    });

     jQuery(rfields).sortable({
         connectWith: lfields,
         containment: '#ewz_ewz_box-scheme_f' + sid + '_',
              handle: ".ewz_hndle",
         helper: "clone",
         receive: function(event, ui ){
                ui.item.find('span.ewz_indicator').show();
         }
     });
}


/************************ Functions Returning an HTML String ****************************************/

function scheme_header_str(sid, scheme){
    var str='';
    str += '<input type="hidden" name="ewzmode" value="ratingscheme">';
    str += '<input type="hidden" name="rating_scheme_id" id="rating_scheme_id' + sid + '_"value="' + scheme.rating_scheme_id + '">';
    str += '<input type="hidden" name="item_layout_id" id="item_layout_id' + sid + '_"value="' + scheme.item_layout_id + '">';
    str += '<div class="ewz_data ewz_95">';

    if (scheme.n_rating_forms > 0) {
       str += '<div class="ewz_warn">Warning: This scheme is in use by ' + scheme.n_rating_forms + ' rating forms.<br />';
       if(  scheme.n_item_ratings > 0 ){
          str +=    ' containing ' + scheme.n_item_ratings + ' ratings<br />';
       }
       str +=    'Changes made now could cause problems.';
       str += '</div> ';
    }

    str +=    '<p class="ewz_sect_title">Rating Scheme for items uploaded using EntryWizard layout "' + scheme.item_layout.layout_name + '"</p>';
    str +=    '<p class="ewz_sect_title">';
    str +=       'General Information';
    str +=    '</p>';
    str +=    '<table>';
    str +=        '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'name\')">&nbsp;Name for this scheme</td>';
    str +=            '<td>' + textinput_str('f' + sid + '_scheme_name_', 'scheme_name', 60, scheme.scheme_name) + '</td>';
    str +=        '</tr>';
    str +=    '</table>';
    str += '</div>';
    return str;
}

/* This box contains the actual rating-scheme fields */
function field_box_str(sid, scheme){
    var str='';
    str += '<div class="ewz_data ewz_95l">';
    str +=    '<span class="ewz_sect_title"><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'field\')">';
    str +=        'Fields to be displayed in Rating';
    str +=    '</span> &nbsp; &nbsp; &nbsp; ';
    str +=    '( <i>Items affected by restrictions ';
    str +=        '<img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'restr1\')">  )';
    str +=    ' are outlined in red and may not be edited</i>';
    str +=    '<div class="ewz_95">';
    str +=       '<div id="ewz_sortable_rfields' + sid + '">';
    // <br> needed at top and bottom to drag a field to the top or bottom
    str +=          '<br />';
     
    for (var i = 0; i < scheme.nth_field.length; ++i) { 
        str += field_str(sid, scheme.nth_field[i],  scheme.fields[scheme.nth_field[i]], true);
    }
    str +=          '<br />';
    str +=       '</div>';
    str +=       '<p><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'ftype\')">&nbsp;Add another field:</p>';
    str +=       '<p>';
    str +=          '<button type="button" class="button-secondary" id="addTextBtn_f' + sid + '_" onClick="add_rfield( this, ' + "'str'" + ')">';
    str +=             'A Text Entry</button> ';
    str +=          '<button type="button" class="button-secondary" id="addOptBtn_f' + sid + '_" onClick="add_rfield( this, ' + "'opt'" + ')">';
    str +=             'A Drop-down Selection</button> ';
    str +=          '<button type="button" class="button-secondary" id="addChkBtn_f' + sid + '_" onClick="add_rfield( this, ' + "'chk'" + ')">';
    str +=             'A Check Box</button> ';
    str +=          '<button type="button" class="button-secondary" id="addLabBtn_f' + sid + '_" onClick="add_rfield( this, ' + "'lab'" + ')">';
    str +=             'A Fixed-Text Label</button>';
    str +=       '</p>';
    str +=    '</div>';
    str += '</div>';

    return str;
}

/* This box contains optional fields for dragging into the actual fields box */
function layout_fields_str(sid,  scheme){
    var str = '';
    var fid, field;

    str += '<div class="ewz_data ewz_95r">';
    str +=    '<span class="ewz_sect_title"><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'field\')">';
    str +=       'Drag items right to display in Rating<br \><br \>Layout Fields:';
    str +=    '</span><br \>';
    str +=    '<div class="ewz_95" id="ewz_layout_fields' + sid + '">';

    str +=          '<br />';
    for ( fid in scheme.item_layout.fields ) { 
        if( scheme.item_layout.fields.hasOwnProperty(fid) ){
            field = scheme.item_layout.fields[fid];
            field.ss_column = -1;
            if( !is_field_displayed( field.field_id, scheme.fields ) ){
                // contents of the postbox to be dragged 
                str +=  field_str( sid, 'X' + newfieldN, field, false );
                ++newfieldN;
            }
        }
    }
    str +=       '<br \><span class="ewz_sect_title">Extra Data:</span><br \>';
    for (var key in ewzG.display) {
        if (ewzG.display.hasOwnProperty(key)) { 
            var disp = ewzG.display[key];
            disp.key = key;
            if( !is_key_displayed( key, scheme.fields ) ){
                // contents of the postbox to be dragged 
                str +=  field_str( sid, 'X' + newfieldN,  disp, false  );
                ++newfieldN;
            }
        }
    }

    str +=          '<br />';
    str +=    '</div>';
    str += '</div>';
    return str;
}

/* The restrictions box */
function all_restrictions_str( sid, scheme ){
    var str = '', restr_count = 0;
    var list = scheme.restr_options[-1];
    for( var i in list ){
        if( list.hasOwnProperty(i) ){
            restr_count++;
        }
    }
        str += '<div class="ewz_95 ewz_data" id="all_restrs_' + sid + '" style="clear:both">';
        str += '<p class="ewz_sect_title"><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'restr\')">';
        str +=     'Optional Restrictions On Allowed Field Values';
        str += '</p>';
        str += '<div class="ewz_95">';
        str +=    '<div id="ewz_restricts_f' + sid + '_">';
         for ( var restr in scheme.restrictions ) {
            if( scheme.restrictions.hasOwnProperty(restr)) {
                str += restriction_str(scheme, sid, restr);
            }
        }
        str +=    '</div>';
        str +=    '<button type="button" id="add_restr_f' + sid + '_" class="button-secondary"  onClick="add_restriction( this)">';
        str +=         'Add A New Restriction';
        str +=    '</button>';
        str += '</div>';
        str += '</div>';
    
    return str;
}

/* Extra data for display in spreadsheet */
function spreadsheet_str(sid, scheme){
    var str = '';
    str += '<div class="ewz_95 ewz_data">';
    str +=    '<p class="ewz_sect_title"><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'xtra\')">';
    str +=        'Extra Data For Display in Spreadsheet Only';
    str +=    '</p>';
    str +=    '<div class="ewz_95">';
    str +=       '<div id="spread_f' + sid + '_" class="ewz_box">';
    str +=          '<h3 id="hspread_f' + sid + '_" class="ewz_hndle"  onClick="toggle_ewz_box(this)">';
    str += '           <span class="ewz_indicator"></span>Select Items</h3>';
    str +=          '<div class="inside"  style="display: none;">';
    str +=             '<table class="ewz_rfield">';

    for (var key in ewzG.display) {
        if (ewzG.display.hasOwnProperty(key)) {
            var kvalue = scheme.extra_cols[key];
            var khead = ewzG.display[key].header;
            var korigin = ewzG.display[key].origin;
            str +=        '<tr><td>' + khead + ' ( <i> ' + korigin + ' data )</i></td>';
            str +=            '<td>';
            str += colinput_str('f' + sid + '_extra_cols_' + key + '_', 'extra_cols[' + key + ']', kvalue, 'ssc' + sid);
            str +=            '</td>';
            str +=        '</tr>';
        }
    }
    str +=             '</table>';
    str +=          '</div>';
    str +=       '</div>';
    str +=    '</div>';
    str += '</div>';

    return str;
}

function display_str( sid, scheme ){ 
    var str = '';
    str += '<div class="ewz_95 ewz_data ewz_scrollx" id="options_' + sid + '" style="clear:both">';
    str += '<table>';
    str += '<tr><td style="vertical-align: top;"><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'idisplay\')">&nbsp;Large Image Display:</td>';
    str +=     '<td colspan="3">';    
    str +=        '<table class="ewz_isettings">';
    str +=          '<tr><td>Max display width of main image in pixels</td>';
    str +=              '<td><input type="text" name="settings[maxw]" id="ewz_settings_maxw'  + sid + '" value="' + scheme.settings.maxw + '"></td>';
    str +=              '<td rowspan="2" class="ewz_td_r"> ' + ewzG.imgSizeNote + '</td></tr>';
    str +=          '<tr><td>Max display height of main image in pixels</td>';
    str +=              '<td><input type="text" name="settings[maxh]" id="ewz_settings_maxh'  + sid + '" value="' + scheme.settings.maxh + '"></td></tr>';
    str +=          '<tr><td class="ewz_td_r">Optional path to custom test image (from uploads folder)  <u>Dimensions must match those above</u></td>';
    str +=               '<td colspan="2"><input type="text" style="width: 380px;" maxlength="200" name="settings[testimg]" id="ewz_settings_testimg' + sid + '" value="' + scheme.settings.testimg + '"> &nbsp; &nbsp;<img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'testimg\')"></td>';
    str +=          '</tr>';
    str +=          '<tr><td>To fit in window, image may shrink to no less than </td><td colspan="2"><select  name="settings[max_shrink]"> id="ewz_settings_max_shrink'  + sid + '" value="' + scheme.settings.max_shrink + '">';
    str +=                     scheme.shrink_options;
    str +=                   '</select>&nbsp;&nbsp;of original dimensions before scrollbars appear. &nbsp; <img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'shrink\')"></td></tr>';
    str +=          '<tr><td>Background color around image ( and text color for link buttons below it )</td>';
    str +=              '<td id="td_bcol' + sid +'"><input class="color-pick" value="' + scheme.settings.bcol + '" type="text" name="settings[bcol]" id="ewz_settings_bcol'  + sid + '">';
    str +=               '</td>';
    str +=           '</tr>';
    str +=          '<tr><td>Background color for link buttons</td>';
    str +=              '<td id="td_fcol' + sid +'"><input class="color-pick" value="' + scheme.settings.fcol + '" type="text" name="settings[fcol]" id="ewz_settings_fcol'  + sid + '">';
    str +=               '</td>';
    str +=           '</tr>';
    str +=          '<tr><td>Minimum height in pixels of background-colour padding above image,to separate it from the url-bar.</td>';
    str +=              '<td><input type="text" size="5" id="ewz_settings_imgpad'  + sid + '" name="settings[img_pad]" value="' + scheme.settings.img_pad + '"></td>';
    str +=          '</tr>';
    str +=       '</table>';

    str +=    '</td>';
    str += '</tr>';
    
    str += '<tr><td> &nbsp; </td></tr>';

    str += '<tr><td style="vertical-align: top;"><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'rpage\')">&nbsp;Rating Page Display:</td>';
    str +=     '<td colspan="3">';    
    str +=        '<table class="ewz_rsettings">';
    str += '<tr>';
    str += '  <td> IF <b>all</b> items are displayed</i><br>';
    str += '      <label for="summ' + sid + '">Show count of completed items in "rate" views: &nbsp; <input type="checkbox" id="summ' + sid + '" name="settings[summary]"';
    if( scheme.settings.summary ){ str += ' checked="checked"'; }
    str +=              '></td>';
    
    str += '  <td><label for="finish' + sid + '">Show "Finished" button in "rate" views';
    str += '      &nbsp; <input type="checkbox" id="finish' + sid + '" name="settings[finished]"';
    if( scheme.settings.finished ){ str += ' checked="checked"'; }
    str +=              '><br>';
    
    str += '  <label for="finish_s' + sid + '">Show "Finished" button in "secondary" views:';
    str += '      &nbsp; <input type="checkbox" id="finish_s' + sid + '" name="settings[finished_s]"';
    if( scheme.settings.finished_s ){ str += ' checked="checked"'; }
    str +=              '><br>';

    str += '  <label for="finish_r' + sid + '">Show "Finished" button in "read" views:';
    str += '      &nbsp; <input type="checkbox" id="finish_r' + sid + '" name="settings[finished_r]"';
    if( scheme.settings.finished_r ){ str += ' checked="checked"'; }
    str +=              '></td>';
    
    str += '  <td><label for="jhelp' + sid + '">Show "Using the Rating Form" help button: &nbsp; <input type="checkbox" id="jhelp' + sid + '" name="settings[jhelp]" ';
    if( scheme.settings.jhelp ){ str += ' checked="checked"'; }
    str +=              '></td>';
    
   
    str +=          '</tr>';
    str +=           '<tr><td colspan="3"> &nbsp; </td></tr>';
    str +=           '<tr><td colspan="3"><i>Leave the settings below at their default values unless the rating page colors are a problem:</i></td></tr>';
    str +=          '<tr><td colspan="2">Main background color for Rating table</td>';
    str +=              '<td><input class="color-pick" value="' + scheme.settings.bg_main + '" type="text" name="settings[bg_main]" id="ewz_settings_bg_main'  + sid + '">';
    str +=               '</td>';
    str +=           '</tr>';
    str +=          '<tr><td colspan="2">Background color for the current row in the Rating table</td>';
    str +=              '<td><input class="color-pick" value="' + scheme.settings.bg_curr + '" type="text" name="settings[bg_curr]" id="ewz_settings_bg_curr'  + sid + '">';
    str +=               '</td>';
    str +=          '</tr>';
    str +=          '<tr><td colspan="2">Border color for a row in the Rating table that has never been saved</td>';
    str +=              '<td><input class="color-pick" value="' + scheme.settings.new_border + '" type="text" name="settings[new_border]" id="ewz_settings_new_border'  + sid + '">';
    str +=               '</td>';
    str +=          '</tr>';
    str +=        '</table>';
    str +=     '</td>';
    str +=  '</tr>';
    str +=  '</table>';
    str +=  '</div>';

    return str;
}

function duplicate_buttons_str(sid, id_num, scheme){
    var str = '';
//    str += '<div style="clear:both;">'
    str += '<div class="buttonrow_l">';
    str +=    '<button type="button" id="lsub_f' + sid + '_' + id_num + '_" class="button-primary" onClick="ewz_check_scheme_input(this, ' + ewzG.jsvalid + ')">';
    str +=         'Save Changes to <i>' + scheme.scheme_name + '</i>';
    str +=    '</button>';
    str +=    '<span class="ewz_waitmessage"></span>';
    str +=    '&nbsp;  &nbsp;  &nbsp;  &nbsp;';
    str += '</div>';
    str += '<div  class="buttonrow">';        
    str +=    '<button type="button" id="lspr_col_f' + sid + '_' + id_num + '_" class="button-secondary" ';
    str +=           'onClick="show_spread_columns(' + "'" + sid + "','" + scheme.scheme_name + "')" + '">Show Summary of Assigned Spreadsheet Columns';
    str +=    '</button>';
    str += '</div>';
//   str += '</div>'

    return str;
}

function save_show_delete_str(sid, id_num, scheme){
    var str = '';
    str += '<div  class="buttonrow_l">';
    str +=    '<button type="button" id="lsub_f' + sid + '_' + id_num + '_" class="button-primary"  onClick="ewz_check_scheme_input(this, ' + ewzG.jsvalid + ')">';
    str +=         'Save Changes to <i>' + scheme.scheme_name + '</i>';
    str +=    '</button>';
    str +=    '&nbsp;  &nbsp;  &nbsp;  &nbsp;';
    str += '</div>';
    str += '<div  class="buttonrow">';    
    str +=     '<button type="button" id="lspr_col_f' + sid + '_' + id_num + '_" class="button-secondary" ';
    str +=          'onClick="show_spread_columns(' + "'" + sid + "', '" + scheme.scheme_name + "')" + '">Show Summary of Assigned Spreadsheet Columns';
    str +=     '</button>';
    str +=     '<span class="ewz_waitmessage"></span>';
    str +=  '</div>';

    str +=   '<div  class="buttonrow_r"><button type="button" id="ldel_f' + sid  + '_" class="button-secondary" ';
    str +=         'onClick="delete_scheme(this, ' + scheme.n_rating_forms + ', ' + scheme.n_item_ratings + ' )">Delete ';
    str +=         '<i>' + scheme.scheme_name + '</i>';
    str +=         '</button>';
    str +=   '</div>';
    return str;
}

/* Returns the html string for a postbox containing a single scheme */
function scheme_str( sid, scheme) {

    var str;
    /*********** Postbox *************/
    str =  '<div id="ewz_admin_schemes_f' + sid + '_" class="metabox-holder">';

    str +=    '<div id="ewz_ewz_box-scheme_f' + sid + '_" class="ewz_box  closed" style="display: block;" >';
    str +=       '<h3 id="tpg_header_f' + sid + '_"  class="ewz_shndle" onClick="toggle_scheme_box(this)">';
    str += '           <span class="ewz_indicator"></span>' + scheme.scheme_name + '</h3>';

    /*********** General *************/
    str +=       '<div class="inside"  style="display: none;">';
    str +=          '<form method="POST" action="" id="sch_form_f' + sid + '_">';
    str +=             '<div class="ewzform">';

    str +=                 scheme_header_str(sid,  scheme);

    str +=                duplicate_buttons_str( sid, '1', scheme );
 
    /*********** Fields *************/
    str +=                '<div class="ewz_95">';
    str +=                   '<table id="ewz_fields_table"><tr><td>';  
    str +=                       layout_fields_str(sid, scheme);
    str +=                   '</td>';

    str +=                   '<td>';  
    str +=                       field_box_str(sid, scheme);
    str +=                   '</td></tr></table>';

    str +=                '</div>';

    str +=                 duplicate_buttons_str( sid, '2', scheme );

    /*********** Restrictions *************/

        str +=                 all_restrictions_str(sid, scheme );

        str +=                duplicate_buttons_str( sid, '3', scheme );

    /*********** Display Options *************/
 
    str +=                 display_str(sid, scheme);

    str +=                 duplicate_buttons_str( sid, '4', scheme );

   /*********** Spreadsheet Data *************/
 
    str +=                 spreadsheet_str(sid, scheme);

    /*********** Save/Delete *************/
   /* str +=                '<div class="ewz_numc">' + ewzG.nonce_string + '</div>';*/
    str +=                save_show_delete_str( sid, '5', scheme );
    str +=             '</div>';
    str +=          '</form>';
    str +=       '</div>';    // inside
    str +=    '</div>';
    str +=    '<div id="spread_cols_display' + sid + '" class="wp-dialog" ></div>';
    str += '</div>';

    return str;
}


/* set up the variables for generating a single field postbox within the field box */
/* ( also used to generate the contents of the draggable fields in the left-hand column ) */
function field_str( sid, rating_field_id,  fObj, show_indicator ) {
    var fld, fid;
    // if rating_field_id is an integer, the item was already on the db
    var saved = ( parseInt( rating_field_id, 10 ) === rating_field_id );
    var ftype = fObj.field_type;
    if( saved ){
        if( ftype != 'fix' && ftype != 'xtr' ){
            ftype = 'edt';
        }
    } else {  
        if( fObj.isnewinput ){
            ftype = 'edt';
        } else {
            ftype = fObj.field_id ? 'fix' :  'xtr';
        }            
    }

    var rfield;
    if( ftype == 'edt' ){
        rfield = fObj; 
        rfield.data_type = type_data_field_str( sid, fid, fld, fObj.field_type, fObj.fdata );
        rfield.rq = rfield.required;
        if( rfield.field_type == 'rad' ){
            rfield.rq = 'disabled';
        }
    } else {
        if( saved ){
            // an already-saved field, may be 'fix', 'xtr' or a regular field
            rfield = fObj; 
            switch( ftype ){
            case 'xtr':   rfield.data_type = 'Extra data ( "' + fObj.fdata.dvalue + '" from ' + fObj.fdata.origin  + ' )';
                break;
            case 'fix': rfield.data_type = 'Data uploaded with item ( "' + fObj.field_header + '" )';
                break;
            }
        } else {
            rfield = { rating_field_id: rating_field_id,
                       field_type: ( ( undefined == fObj.field_id ) ? 'xtr' : 'fix' ),
                       field_header: fObj.field_header || fObj.header,
                       field_ident:  fObj.field_ident || fObj.key
                     };
             if( undefined == fObj.field_id ){
                 rfield.fdata = { origin: fObj.origin, dobject: fObj.dobject, dvalue: fObj.header, dkey: fObj.key };
                 rfield.data_type = 'Extra data ( ' + fObj.header + ' from ' + fObj.origin  + ' )';
             } else {
                 rfield.fdata = { field_id: fObj.field_id };
                 rfield.data_type = 'Data uploaded with item ( ' + fObj.field_header + ' )';
             } 
         }         
    }

    rfield.saved = saved;
    rfield.ftype = ftype;
   
    fld = 'fields[' + rfield.rating_field_id + ']';
    fid = 'sch' + sid + '_fields' + rfield.rating_field_id + '_';

    return rating_field_str( sid, fld, fid, rfield, show_indicator );
}

/* return the html for a single field postbox within the field box */
function rating_field_str( sid, fld, fid, rfield, show_indicator )
{
    var str = '';
    var displ = show_indicator ? '' : 'style="display:none;"';
    /* field_mbox_ required at start of id */
    str += '<div id="' + fid + 'field_mbox_" class="ewz_box  closed">';
    str +=   '<h3  id="field_title_' + fid + '" class="ewz_hndle" onclick="maybe_toggle_ewz_box(this)">';   
    str += '      <span class="ewz_indicator" ' + displ + '></span>' + rfield.field_header + '</h3>';
    str +=   '<div class="inside">';
    str +=      '<input type="hidden" name="' + fld + '[rating_field_id]' + '" value="' + rfield.rating_field_id + '">';
    str +=      '<input type="hidden" name="forder[]" value="forder_f' + sid + '_c' + rfield.rating_field_id + '_">';

    if( rfield.field_type == 'xtr' || rfield.field_type == 'fix' ){
        str +=  '<input type="hidden" name="' + fld + '[field_ident]' + '" value="' + rfield.field_ident + '">';   
        str +=  '<input type="hidden" name="' + fld + '[field_type]'  + '" value="' + rfield.field_type + '">';
        str +=  '<input type="hidden" name="' + fld + '[required]'    + '" value=true>';
    }
    if( rfield.field_type == 'xtr' ){
        str +=  '<input type="hidden" name="' + fld + '[fdata][origin]'  + '" value="' + rfield.fdata.origin + '">';
        str +=  '<input type="hidden" name="' + fld + '[fdata][dobject]' + '" value="' + rfield.fdata.dobject + '">';
        str +=  '<input type="hidden" name="' + fld + '[fdata][dvalue]'  + '" value="' + rfield.fdata.dvalue + '">';
        str +=  '<input type="hidden" name="' + fld + '[fdata][dkey]'    + '" value="' + rfield.fdata.dkey + '">';
    }
    if( rfield.field_type == 'fix' ){
        str +=  '<input type="hidden" name="' + fld + '[fdata][field_id]' + '" value="' + rfield.fdata.field_id + '">';
    }

    str +=      '<div class="ewz_scrollx">';
    str +=      '<table  class="ewz_rfield">';

    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'webcol\')">';
    str +=                  '&nbsp;Column Header For Web Page: ';
    str +=              '</td>';
    str +=              '<td>';  
    /* Usable description must be in first row */
    str +=                  textinput_str(fid + 'field_header_', fld + '[field_header]', 50, rfield.field_header, 'onChange="update_title(this)"' );
    str +=              '</td>';
    if( rfield.ftype == 'edt' ){
       str +=           '<td rowspan="5"  id="special_' + fid + '" > ' + type_data_field_str(sid, fid, fld, rfield.field_type, rfield.fdata );
       str +=           '</td>';
    }
    str +=          '</tr>';
   
    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'dtype\')">';
    str +=                  '&nbsp;Data Type: ';
    str +=              '</td>';
    if( rfield.ftype == 'edt' ){
        str +=          '<td class="ewz_shaded">' + type_opt_str(sid, fid, fld, rfield.field_type ) + '</td>';
    } else {
        str +=          '<td>' + rfield.data_type + '</td>'; 
    }
    str +=          '</tr>';

    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'ident\')">';
    str +=                     '&nbsp;Field Identifier: ';
    str +=              '</td>';
    str +=              '<td>' + textinput_str(fid + 'field_ident_', fld + '[field_ident]', 15, rfield.field_ident) + '</td>';
    str +=          '</tr>';
 
    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'sscol\')">';
    str +=                     '&nbsp;Spreadsheet Column: ';
    str +=              '</td>';
    str +=              '<td>' + colinput_str(fid + 'ss_column_', fld + '[ss_column]', rfield.ss_column, 'ssc' + sid ) + '</td>';
    str +=          '</tr>';

    if( rfield.ftype == 'edt' ){
        var change = ' onChange="req_no_max(this)"';
        str +=      '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'req\')">&nbsp;Required: </td>';
        str +=          '<td>' + checkboxinput_str(fid + 'required_', fld + '[required]', rfield.required, change ) + '</td>';
        str +=      '</tr>';
    }

    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'append\')">';
    str +=                      '&nbsp;Append to Previous Column in Webform: ';
    str +=              '</td>';
    str +=              '<td>' + checkboxinput_str(fid + 'append_', fld + '[append]', rfield.append ) + '</td>';
    str +=          '</tr>';

    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'divide\')">';
    str +=                      '&nbsp;Divide among Judges: ';
    str +=              '</td>';
    str +=              '<td>' + checkboxinput_str(fid + 'divide_', fld + '[divide]', rfield.divide ) + '</td>';
    str +=          '</tr>';
    
    str +=          '<tr><td><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'secondary\')">';
    str +=                      '&nbsp;Display in a "secondary" view only: ';
    str +=              '</td>';
    str +=              '<td>' + checkboxinput_str(fid + 'is_second_', fld + '[is_second]', rfield.is_second ) + '</td>';
    str +=          '</tr>';
    str +=      '</table>';
    str +=      '</div>';
    if( rfield.saved || rfield.ftype == 'edt' ){
        str +=   '<div style="text-align:right; padding:10px;"> ';
        str +=      '<button type="button" class="button-secondary" id="del_' + fid + '" onClick="delete_rfield(this)">Delete Field</button>';
        str +=   '</div>';
    }
    str +=    '</div>';  // class = "inside"
    str += '</div>';
    return str;
}

/* contents of a single restriction postbox */
function restriction_str( scheme, sid, rnum ) {
    var txt, msgnm, msg, newnum, list;
    var rid = "add_restr_" + sid +  "_R" + rnum + '_';
    list =  scheme.restr_options[-1];
    if( scheme.restr_messages[rnum ] == undefined ){
        newnum = -1;
        msg = "--- New Restriction ---";
    } else {
        newnum = rnum;
        msg = scheme.restr_messages[rnum];
    }
    msgnm = 'restrictions[' + rnum + '][msg]';

    txt  = '<div id="restr_title_f' + sid + '_r' + rnum + '_" class="ewz_subpost ewz_box closed">';
    txt += '   <h3 id="restr_f' + sid + '_r' + rnum + '_" class="ewz_hndle"  onClick="toggle_ewz_box(this)">';
    txt += '           <span class="ewz_indicator"></span>' + msg + '</h3>';
    txt += '   <div class="inside"  style="display: none;">';

    txt += '      <div class="ewz_add_restr" id="' + rid + '">';
    txt += '         <table class="ewz_rfield">';
    txt += '            <tr><td>Forbidden combination:</td>';
     txt += '               <td><i>(starred items may not be changed by the judge)</i></td>';
    txt +=             '</tr>';
    for( var field_id in scheme.fields ) {
        if( scheme.fields.hasOwnProperty(field_id) ){
            var field = scheme.fields[field_id];
            if( field.is_second ){ continue; }
            var is_opt = ( ( field.field_type == 'opt' ) || ( ( field.field_type == 'fix' ) && ( field.fixfield.field_type == 'opt' ) ) );
            var nmstr = 'restrictions[' + rnum + '][' + field_id + ']';
            var mult = is_opt ? ' multiple="multiple"' : '';
            var fixflag = ( field.field_type == 'fix' || field.field_type == 'xtr' || field.field_type == 'lab' ) ? ' *' : '';
            if( undefined !== list[field_id] && list[field_id].length > 0 ){
                txt += '<tr><td class="ewz_leftpad">' + field.field_header  + ":</td>";
                txt += ' <td class="ewz_leftpad">';
                txt += '        <select name="' + nmstr  + '[] " id="f' + sid + '_restrictions_' + rnum + '__' + field_id + '_" ' + mult + ' >';
                txt +=              scheme.restr_options[newnum][field_id];                
                txt += '        </select>' + fixflag ;
                txt += '    </td>';
                    
                txt += '</tr>';
            }
        }
    }    
    txt +=             '<tr><td ><img  class="ewz_ihelp" src="' + ewzG.helpIcon + '" onClick="ewz_help(\'rmsg\')">&nbsp;Message: </td>';
    txt +=                 '<td>';
    txt +=                 '   <input type="text" name="' + msgnm + '" id="f' + sid + '_restrictions_' + rnum + '__msg_" value="';
    if( scheme.restr_messages[rnum ] != undefined ){
        txt +=                      msg;
    }
    txt +=                     '">';
    
    txt +=                 '</td>';
    txt +=             '</tr>';
    txt +=          '</table>';
    txt +=       '</div>';
    txt +=       '<p style="text-align:right">';
    txt +=          '<button type="button" class="button-secondary" id="x' + rid + '" onClick="delete_restriction(this)">Remove Restriction</button>';
    txt +=       '</p>';
    txt +=    '</div>'; // inside
    txt += '</div>';
    
    return txt;
}

/* buttons to add a new scheme */
function add_scheme_button_str() {
    
    var str = '<div class="ewz_scrollx" style="clear:both">';
    str += '<table id="ewz_control" >';
    str +=    '<tr>';
    str +=       '<td><img  class="ewz_ihelp" src="' +  ewzG.helpIcon + '" onClick="ewz_help(\'lsort\')"></td>';
    str +=       '<td><button  type="button" id="add_scheme" class="button-secondary" onClick="new_rating_scheme()">';
    str +=               'Add a New Scheme';
    str +=            '</button>';
    str +=        '</td>';
    str +=        '<td>for items uploaded using layout: ';
    str +=        '</td>';
    str +=        '<td>';
    str +=             '<select id="ewz_add_for_layout" >';
    str +=                   ewzG.layout_options;
    str +=             '</select>';
    str +=        '</td>';
    str +=     '</tr>';
    str +=     '<tr>';
    str +=       '<td>&nbsp;</td>';
    str +=        '<td>';
    str +=           '<button  type="button" id="copy_scheme" class="button-secondary" onClick="copy_rating_scheme();">';
    str +=               'Add a New Scheme';
    str +=           '</button>';
    str +=        '</td>';
    str +=        '<td>';
    str +=            'with options copied from: ';
    str +=        '</td>';
    str +=        '<td>';
    str +=            '<select id="ewz_add_for_scheme" >';
    str +=                 ewzG.scheme_options;
    str +=             '</select>';
    str +=        '</td>';
    str +=        '<td class="ewz_waitmessage"></td>';    
    str +=     '</tr>';
    str +=  '</table>';
    str += '</div>';
    str +=        '<button  type="button" class="button-secondary ewz_orderbtn" id="schemes_save2_" onClick="save_scheme_order()">';
    str +=                 'Save Order of Schemes';
    str +=        '</button>';
    return str;
}


/************************ Batch Functions  ****************************************/

function save_scheme_order(){
    var sc_nonce = jQuery('#ewznonce').val();
    var data = {
        action: 'ewz_save_scheme_order',
        ewznonce:   sc_nonce,
        ewzmode:  'sc_set',
        scorder: new Object()
    };

    if( jQuery('input[id^="rating_scheme_id"][value=""]').length > 0 ){
        ewz_alert("RS002", "Please save your unsaved rating schemes before trying to rearrange them", ++popupN);
        return;
    }
        
    jQuery('input[id^="rating_scheme_id"]').each(function(index){
        data['scorder'][jQuery(this).val()] = index;
    });
    data['action'] = 'ewz_save_scheme_order';
    data['ewznonce'] = sc_nonce;
   // ajaxurl variable is available in admin
    var jqxhr = jQuery.post( ajaxurl,
                             data,
                             function (response) {
                                 jQuery("#temp_del").remove();
                                     ewz_alert( 'RS003', response, ++popupN );
                             }
                           ).fail( function( jqXHr, textStatus, errorThrown ){ ewz_alert( 'RS011', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );       
}

/************************ Individual Scheme Setup Functions  ****************************************/

/* Set up some onChange functions */
/* Enable/Disable some items      */
/* Set some attributes           */
function setup_scheme( sid ) {

    add_variance(sid);

    // set postbox header from title
    jQuery('#f' + sid + '_scheme_name_').on("keyup", function() {
        update_scheme_name(this);
    });
    jQuery('#f' + sid + '_scheme_name_').on("change",function() {
        update_scheme_name(this);
    });

    // disable ss_column values that are in use already
    disable_ss_options('.ssc' + sid);
    // now run the function defined above
    jQuery("#f" + sid + "_max_num_items_").trigger("change");

    var jScheme = jQuery('#ewz_admin_schemes_f' + sid + '_');

    // remove "Formatted Text" inputs, used for entrywizard only
    jScheme.find('tr.reformat').remove();

    // disable fields appearing in restrictions
    disable_restricted_fields(sid);

    // disable required label field
    disable_required_for_lbl_or_rad(sid);

    // set the color picker 
    jScheme.find( '.color-pick' ).wpColorPicker();

    // note when changes made
    jScheme.find( ':input:not(:button)').on("change", function(){                
        if(!g_changesMade){ g_changesMade=true; }      
    });

    set_drag_drop(sid);
}

function new_rating_scheme(){
 
    var layout_id = jQuery('#ewz_add_for_layout').val();
    if( layout_id == undefined ){
        ewz_alert('Please select a layout');
    }
    var scheme =  ewzG.empty_scheme;
    
    for( var i = 0; i < ewzG.item_layouts.length; ++i ){
       if( ewzG.item_layouts[i].layout_id == layout_id ){
           scheme.item_layout = ewzG.item_layouts[i];
           scheme.item_layout_id = layout_id;
           scheme.settings['maxw'] = ewzG.layout_img_dims[layout_id][0];
           scheme.settings['maxh'] = ewzG.layout_img_dims[layout_id][1];
           if( ewzG.item_layouts[i].n_items < 1 ){
               ewz_confirm( "Warning: there are no items uploaded for this layout. Still create the rating scheme?",
                            function(){ do_create_scheme( scheme ); },
                            null,
                            ++popupN);
           } else {
              do_create_scheme( scheme );
           } 
       }
    }
}
function copy_rating_scheme(){
    var fromid  = jQuery('#ewz_add_for_scheme').val();
    if( fromid == undefined ){
        ewz_alert('Please select a scheme to copy');
    }
    var fromnum = jQuery('#ewz_add_for_scheme').prop("selectedIndex");

    add_variance(fromid);
    
    var schemes = jQuery('div[id^="ewz_admin_schemes_f"]');
    var to_num = 'X' + newschemeN;
    ++newschemeN;

    var fromstringid = 'ewz_admin_schemes_f' + fromid + '_';
    var tostringid = 'ewz_admin_schemes_f' + to_num + '_';
    var jQnew = jQuery('#' + fromstringid).clone();
    
    var sscstr = new RegExp('ssc' + fromid + '(\D)', "g");
    var newhtml = jQnew.html().replace(sscstr, 'ssc' + to_num + '$1');
    jQnew.html(newhtml);

    jQnew.attr("id", tostringid);
    var re = new RegExp(fromid);     // NB: no "g", only replace first occurrence
    jQnew.find('[id]').each(function() {
        jQuery(this).attr("id", jQuery(this).attr("id").replace(re, to_num ));
    });
    jQnew.find('input[name="forder[]"]').each(function() {
        jQuery(this).attr("value", jQuery(this).attr("value").replace('_f' + fromid + '_', '_f' + to_num + '_'));
    });
    jQnew.find('label').each(function() {
        if(jQuery(this)[0].hasAttribute("for") ){
            jQuery(this).attr("for", jQuery(this).attr("for").replace(fromid, to_num));
        }
    });

    // remove restrictions, will be copied on save
    jQnew.find('#ewz_restricts_f' + to_num + '_').empty();

    jQnew.find('input[name="rating_scheme_id"]').attr("value", "");
    jQnew.find('input[name$="[rating_field_id]"]').attr("value", "");
    jQnew.find('select:disabled,textarea:disabled,input:disabled,button:disabled').prop("disabled", false);

    jQnew.find('div[class="ewz_warn"]').html('');
    var oldname = jQuery('#' + fromstringid).find('input[id$="scheme_name_"]').val();
    // make sure the new scheme_name is within the limit of 60 chars
    jQnew.find('[id$="scheme_name_"]').first().attr("value", '--- Copy of ' + oldname.substring( 0, 45 ) + ' --');  

    jQnew.insertAfter(schemes.last());
    enable_restricted_fields(to_num);

    setup_scheme( to_num );
   /* jQnew.find('.ewz_numc').html(ewzG.nonce_string); */
    jQnew.find('input[id$="scheme_name"]').trigger("click");
    jQuery( '.color-pick' ).wpColorPicker();
    g_changesMade = true;
    do_submit( jQnew.find('form[id^="sch_form"]'), to_num, fromid );
   
}

function do_create_scheme( scheme ){

    var new_sid = 'X' + newschemeN;
    ++newschemeN;
      
    scheme.scheme_name = '--- New Rating Scheme for ' + scheme.item_layout.layout_name + ' ---';

    jQuery('#ewz_schemes').append( scheme_str( new_sid, scheme ) );
    setup_scheme( new_sid );

    var jNew = jQuery('#ewz_admin_schemes_f' + new_sid + '_');
    jNew.find('input[name="rating_scheme_id"]').val('');

    jNew.find('#add_restr_f' + new_sid + '_').after(" &nbsp; <i>Restrictions may not be added until the rating scheme (with all its fields) has been saved.</i>");
    jNew.find('#add_restr_f' + new_sid + '_').prop("disabled", true);

}  

function toggle_scheme_box( handle ){
    var sid = get_scheme_ident( handle );
    jQuery(handle).closest('.ewz_box').children(".inside").toggle();
    if( !schemes_done[sid] ){
        setup_scheme(sid);
        schemes_done[sid] = true;
    }
    jQuery(handle).toggleClass('ewz_shndle');
    jQuery(handle).children('span.ewz_indicator').first().toggleClass('ewz_open');
}




/************************ Individual Scheme Functions  ****************************************/

/* Called on change of scheme name, to change the ewz_box title */
function update_scheme_name(textfield) {
    var jtext, jscheme;

    jtext = jQuery(textfield);
    jscheme = jtext.closest(jQuery('div[id^="ewz_ewz_box-scheme_f"]'));
    jscheme.find('h3[id^="tpg_header_f"]').text(jtext.val());
    jscheme.find('button[id^="lsub_f"] i').text(jtext.val());
    jscheme.find('button[id^="ldel_f"] i').text(jtext.val());
}


/* Just deletes the scheme from the current page, does not change what is stored on the server */
function delete_js_scheme( id, thediv, lname ) {
    thediv.remove();
    var index = js_find_by_key(ewzG.schemes, 'rating_scheme_id', id);   
    ewzG.schemes.splice(index, 1);
    jQuery('#ewz_add_for_scheme').find('option:contains(' + lname + ')').remove();
}

/* First checks for attached webforms or items */
/* Actually deletes the scheme on the server via ajax. If successful, calls delete_js_scheme to delete it on the current page. */
function delete_scheme(button, nratingforms, nratings) {
    var jbutton = jQuery(button);
    var thediv = jbutton.closest('div[id^="ewz_admin_schemes_f"]');
    var id = thediv.find('input[name="rating_scheme_id"]').first().attr("value");
    var lname = jbutton.closest('div[id^="ewz_ewz_box-scheme_f"]').find('h3[id^="tpg_header_f"]').text();
    lname = lname.replace(/To make it permanent.*$/, '');
    if (id === undefined || null === id || '' == id ) {
        delete_js_scheme(id, thediv, lname);
        return;
    } 
    if (nratings > 0) {
        ewz_alert('RS004', ewzG.errmsg.deletehasratings, ++popupN);
        return;
    }
    ewz_confirm( ewzG.errmsg.deleteconfirm,
                 function(){ 
                     do_delete_scheme( thediv, jbutton, id, lname  );
                 },
                 null,
                 ++popupN);    
}

function do_delete_scheme( thediv, jbutton, id, lname ){
    var del_nonce = jQuery('#ewznonce').val();
    jbutton.after('<span id="temp_load" style="text-align:left"> &nbsp; <img  src="' + ewzG.load_gif + '"/></span>');
   // ajaxurl variable is available in admin
    var jqxhr = jQuery.post(ajaxurl,
                        {
                            action: 'ewz_del_scheme',
                            rating_scheme_id: id,
                            ewznonce: del_nonce
                        },
                        function(response) {
                            jQuery("#temp_load").remove();
                            if ('1' == response) {
                                delete_js_scheme(id, thediv, lname);
                            } else {
                                ewz_alert('RS005', response, ++popupN);
                            }
                        }
                       ).fail( function( jqXHr, textStatus, errorThrown ){ ewz_alert( 'RS012', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );
}


/************************ Field and Restriction Functions ****************************************/

/* toggle the field box only if it is in the main fields box, not in the draggables box */
function maybe_toggle_ewz_box(handle) {
    var jhndle = jQuery(handle);
    var jbox = jhndle.closest('.ewz_box');
    var jfields = jhndle.closest( 'div[id^="ewz_sortable_rfields"]' );
    if( jfields.length > 0 ){
        jhndle.toggleClass('ewz_hndle');
        jhndle.find('span.ewz_indicator').toggleClass('ewz_open').show();
        jbox.children(".inside").toggle();
    } else {
        // needed if dragged back to layout fields area
        jbox.children(".inside").hide();
        jhndle.find('span.ewz_indicator').hide();
    }
}

/* disable editing of fields appearing in restrictions */
function disable_restricted_fields(sid) {
    jQuery("#ewz_restricts_f" + sid + '_').find('option:selected').each(function() {
        if (jQuery(this).val() !== '~*~') {
            var field_id, optval, jTxt;
            field_id = jQuery(this).parent().attr('id').replace(/^.*__/, '').replace('_', '');
            disable_and_flag(jQuery('#sch' + sid + '_fields' + field_id + '_field_type_'));
            disable_and_flag(jQuery('#sch' + sid + '_fields' + field_id + '_is_second_'));
            disable_and_flag(jQuery('#del_sch' + sid + '_fields' + field_id + '_'));
            optval = jQuery(this).val();
            switch (optval) {
                case "~+~":
                case "~-~":
                    disable_and_flag(jQuery('#sch' + sid + '_fields' + field_id + '_required_'));
                    break;
                default:
                    jTxt = jQuery("input[id^='sch" + sid + "_fields" + field_id + "_fdata_'][id$='_value_'][value='" + optval + "']");
                    disable_and_flag(jTxt.parent().siblings().last().find("button"));
                    disable_and_flag(jTxt);
                    break;
            }
        }

    });
}

/* disable "required" checkbox if the field type is radio or label */
function disable_required_for_lbl_or_rad(sid){
    jQuery("#ewz_sortable_rfields" + sid ).find('select[id$="_field_type_"]').each(function(){
        var jthis = jQuery(this);
        var type = jthis.val();
        if( type == 'rad' ){
            jthis.closest('table[class="ewz_rfield"]').find('input[id$="_required_"]').prop("checked", false).prop("disabled", true);
        }
        if( type == 'lab' ){
            jthis.closest('table[class="ewz_rfield"]').find('input[id$="_required_"]').prop("checked", true).prop("disabled", true);
        }
    });
}

/* enable fields disabled via  disable_restricted_fields*/
function enable_restricted_fields(sid) {
    var content;
    jQuery("#sch_form_f0_").find(".ewz_disabled").each(function() {
        jQuery(this).find('input,button').prop("disabled", false);
        content = jQuery(this).html();
        jQuery(this).replaceWith(content);
    });
}

/* Adds a new field to the current scheme, of type defined by field_type */
function add_rfield(add_field_btn, field_type) {
    var form = jQuery(add_field_btn).closest('form[id^="sch_form"]');
  
    var newid = 'X' + newfieldN;
    var newfid = form.attr("id").replace('sch_form_', '') + 'fields' + newid + '_';
    var sid = form.attr("id").replace('sch_form_f', '').replace('_', '');

    var fdata = {};

    var data = {};
    fdata = get_empty_field_str( field_type ); 
    data.fdata = fdata;
    data.field_ident = '';
    data.field_header = '';
    data.rating_field_id = newid;
    data.field_type = field_type;
    data.required = 0;
    data.ss_column = '-1';
    data.isnewinput = 1;

    form.find('div[id^="ewz_sortable"]').append( jQuery(field_str(sid, newid, data)) );
    
    disable_required_for_lbl_or_rad(sid);

    var jNewBox = jQuery('#sch' + sid + '_fields' + newid + '_field_mbox_');
    // fire a change event on the spreadsheet column select boxes to disable used columns
    jNewBox.find('select[id$="ss_column_"]').trigger("change");

    jNewBox.find(':input:not(:button)').on("change", function(){
        if(!g_changesMade){g_changesMade=true;}
    });
    jQuery('h3[id="field_title_sch' + sid + '_fields' + newid + '_"]').html("-- New Field --");

    // remove "Formatted Text" inputs
    jNewBox.find('tr.reformat').remove();
    if( field_type == 'opt' ){
        add_variance_to_field( sid, newid, "-1");
    }

    ++newfieldN;
}
  
/* Just deletes the field on the current page, does not change what is stored on the server */
function delete_js_field( rating_scheme_id, rating_field_id, jdiv ) {
    var index = js_find_by_key(ewzG.schemes, 'rating_scheme_id', rating_scheme_id);
    jdiv.find('select[onchange^="disable_ss_options"]').prop("selectedIndex", 0);
    delete ewzG.schemes[index].fields[rating_field_id];
    jdiv.remove();
    jQuery('select[id*="restrictions"][id$="__' + rating_field_id + '_"]').remove();
}


/* Actually deletes the field on the server via ajax. If successful, deletes it on the current page. */
function delete_rfield(del_field_btn) {
    var jbutton, fname, jfield_div, jform_div, rating_field_id, scheme_id, del_nonce, jqxhr;

    jbutton = jQuery(del_field_btn);
    jfield_div = jbutton.closest('div[id$="field_mbox_"]');
    rating_field_id = jfield_div.find('input[name^="fields"]').filter(":hidden").val();
    if ( rating_field_id === undefined || '' == rating_field_id || '0' == rating_field_id || rating_field_id.match(/^X/)) {
        jfield_div.find('select[onchange^="disable_ss_options"]').prop("selectedIndex", 0);
        jfield_div.find('select[onchange^="disable_ss_options"]').trigger("change");
        jfield_div.remove();
    } else {
        fname = jfield_div.find('h3[id^="field_title"]').text();
        ewz_confirm( "Really delete the '" + fname + "' field?",
                     function(){ 
                         do_delete_field(jbutton, jfield_div, rating_field_id );
                     },
                     null, ++popupN );
    }
}

function do_delete_field( jbutton, jfield_div, rating_field_id ){
      var jform_div = jbutton.closest('form[id^="sch_form_f"]');
      var scheme_id = jform_div.find('input[name="rating_scheme_id"]').filter(":hidden").val();
      var del_nonce = jQuery('#ewznonce').val();
      jbutton.after('<span id="temp_load" style="text-align:left"> &nbsp; <img  src="' + ewzG.load_gif + '"/></span>');
      // ajaxurl variable is available in admin
      var jqxhr = jQuery.post(ajaxurl,
              {
                  action: 'ewz_del_rating_field',
                  rating_field_id: rating_field_id,
                  scheme_id: scheme_id,
                  ewznonce: del_nonce
              },
      function(response) {
          jQuery("#temp_load").remove();
          if ('1' == response) {
              delete_js_field(scheme_id, rating_field_id, jfield_div);
          } else {
              ewz_alert('RS006', response, ++popupN);
          }
      }
      ).fail( function( jqXHr, textStatus, errorThrown ){ ewz_alert( 'RS013', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );
}

/************************ Restrictions  ****************************************/

function add_restriction(button) {
    var jButton = jQuery(button);
    var jRestrictDiv = jButton.parent().find('div[id^="ewz_restricts_f"]');
    var sident = get_scheme_ident(button);
    var snum = jButton.closest( 'div[id^="ewz_admin_schemes_f"]').prevAll('div[id^="ewz_admin_schemes_f"]').length;
    var nrestrs = jButton.closest('div[id^="all_restrs_"]').find('div[id^="restr_title_f"]').length;
    jRestrictDiv.append(restriction_str( ewzG.schemes[snum], sident, nrestrs ));
    jRestrictDiv.find(':input:not(:button)').on("change", function(){
        if(!g_changesMade){g_changesMade=true;}
    });
}

function delete_restriction(button) {
    var sid = get_scheme_ident(button);
    // delete the restriction
    jQuery(button).closest('.ewz_box').remove();
    enable_restricted_fields(sid);
    // there may be other restrictions, enable clears everything
    disable_restricted_fields(sid);
}


/************************ Individual Scheme Check and Save Functions  ****************************************/

var ewz_errors_done;  // global
function ewz_check_scheme_input(button, do_check) {
    var except1;
    var ok = true;
    var has_req = false;
    var warning = '';
    var jform = jQuery(button).closest('form');
    var sid = jform.attr("id").replace('sch_form_f', '').replace('_', '');
    
    // stop the "do you really want to leave" message that would otherwise show when the "save changes" button is clicked
    g_doingSubmit = true;  

    ewz_errors_done = [];

    jQuery('button[id^="lsub_f' + sid + '_"]').prop("disabled", true);
    try {
        if (do_check) {
            
            // remove leading and trailing spaces from all inputs
            // NB: need index arg so value is correctly assigned
            jform.find('input').val(function(index, value) {
                return value.replace(/ +$/, '').replace(/^ +/, '');
            });
            
            // do_all_checks pops up notices asynchronously
            ok = ok && do_all_checks(jform, sid);
            
            if( ok ){
                
                // get_all_confirms does not pop up confirmation dialogs, just returns a message
                warning = get_all_confirms(jform);
                ok = ok && ( warning.length == 0 );
            } 
            if( warning.length > 0 ){
                
                // now show the asynchronous confirmation dialog, and submit if confirmed
                // the do_submit call may be executed after ewz_check_scheme_input  has finished
                ewz_confirm( warning,
                             function(){
                                 do_submit(jform, sid);
                             },
                             null,
                             ++popupN );

            } else if( ok ){
                
                do_submit(jform, sid);
            }
        } else {
             
            do_submit(jform, sid);
        }
    } catch (except1) {
         
        jQuery('button[id^="lsub_f' + sid + '_"]').prop("disabled", false);
        ewz_alert( "RS007", "Sorry, there was an unexpected error: " + except1.message, ++popupN);
        return false;
    }       

    
    jQuery('button[id^="lsub_f' + sid + '_"]').prop("disabled", false);
    g_doingSubmit = false;
    return false;       // must do this to prevent re-sending via regular submit
}

function get_all_confirms(jform){
    var warning = '';
    // warn if no required field
    if( jform.find('input:checked[id$="_required_"]').length == 0 ) {
        warning = warning +  ewzG.errmsg.noreqfield;
    }
    return warning;
}

function do_all_checks( jform, sid ){
    var ok = true;
    // no scheme name
    
    if (!jform.find('input[id$="_scheme_name_"]').val()) {
        err_alert( sid, ewzG.errmsg.schemename);
        ok = false;
    }
     

    // no fields
    if (!jform.find('div[id$="field_mbox_"]')) {
        err_alert( sid, ewzG.errmsg.nofields);
        ok = false;
    }
     
    /* cant return from function from inside filter, so use 'ok' flag */
    // missing column header
    jform.find('input[id$="field_header_"]').filter(function() {
        return  ('' == jQuery(this).val().replace(/^\s+|\s+$/g, ''));
    }).each(function() {
        err_alert( sid, ewzG.errmsg.colhead);
        ok = false;
    });
     
    // invalid identifier
    jform.find('input[id$="field_ident_"]').filter(function() {
        return !jQuery(this).val().replace(/^\s+|\s+$/g, '').match(/^[a-z][a-z0-9_\-]+$/i);
    }).each(function() {
        err_alert( sid, ewzG.errmsg.ident);
        ok = false;
    });
     
    // missing option label or value
    jform.find('input[id$="_label_"]').each(function() {
        var lab = jQuery(this).val();
        if (!lab) {
            err_alert( sid, ewzG.errmsg.optlabel);
            ok = false;
            return;
        }
        if (lab.match(/[^A-Za-z0-9_\.\- ]/)) {
            err_alert( sid, ewzG.errmsg.option);
            ok = false;
        }
    });
         

    // option list must contain a valid option
    jform.find('select[id$="_field_type_"]').each(function(){
        if( jQuery(this).val() === 'opt'){
            var jfield_table = jQuery(this).closest('table[class="ewz_rfield"]');
            var header = jfield_table.find('input[id$="_field_header_"]').val();
            if(jfield_table.find('table[id^="data_fields_"]').find('tr[id$="_row_"]').length < 1 ){
                err_alert( sid,  header + ': ' +  ewzG.errmsg.optioncount );
                ok = false;
            }
        }
    });
     

    
    // option must have a valid value
    jform.find('input[id$="_value_"]').each(function() {
        var oval = jQuery(this).val();
        if (!oval) {
            err_alert( sid, ewzG.errmsg.optvalue);
            ok = false;
            return;
        }
        if (oval.match(/[^A-Za-z0-9_\.\-]/)) {
            err_alert( sid, ewzG.errmsg.option);
            ok = false;
        }
    });
         
    // Text for blank selection must be valid
    jform.find('input[id$="[selecttext]"]').each(function(){
        if( jQuery(this).val().match(/[^A-Za-z0-9_\.\-\ ]/)) {
            err_alert( sid, ewzG.errmsg.selecttext);
            ok = false;
        }
    });

   // invalid checkbox label
    jform.find('input[id$="chklabel_"]').each(function() {
        var lab = jQuery(this).val();
        if (lab.match(/[^A-Za-z0-9_\.\- ]/)) {
            err_alert( sid, ewzG.errmsg.chklabel);
            ok = false;
        }
    });
         

   // invalid fixed text label value
    jform.find('input[id$="_textlabel_"]').each(function() {
        var lab = jQuery(this).val();
        if( !lab ){
            err_alert( sid, ewzG.errmsg.labvalue);
            ok = false;
            return;
        }
        if (lab.match(/[^A-Za-z0-9_\.\- ]/)) {
            err_alert( sid, ewzG.errmsg.textlabel);
            ok = false;
        }
    });
         

    // restriction must have a message
    jform.find('input[id$="__msg_"]').each(function() {
        if (!jQuery(this).val()) {
            err_alert( sid, ewzG.errmsg.restrmsg);
            ok = false;
        }
    });
         

    // text input must have maxchars
    jform.find('select[id$="_maxstringchars_"]').each(function() {
        if (!jQuery(this).val().replace(/^\s+|\s+$/g, '')) {
            err_alert( sid, ewzG.errmsg.maxnumchar);
            ok = false;
        }
    });
         

    // Image specs must be digits only
    jform.find('input[id^="ewz_settings_maxh"]').each(function() {
        if( !( jQuery(this).val().match(/^[1-9][0-9][0-9][0-9]?$/)  ) ) {
            err_alert( sid, ewzG.errmsg.maximgh);
            ok = false;
        }
    });
         
    jform.find('input[id^="ewz_settings_maxw"]').each(function() {
        if( !( jQuery(this).val().match(/^[1-9][0-9][0-9][0-9]?$/)  ) ) {
            err_alert( sid, ewzG.errmsg.maximgw);
            ok = false;
        }
    });
         
    jform.find('input[id^="ewz_settings_imgpad"]').each(function() {
        if( !( jQuery(this).val().match(/^[1-9][0-9][0-9]?$/) ) ) {
            err_alert( sid, ewzG.errmsg.minpad);
            ok = false;
        }
    });
         

    // warnings re ineffective restrictions
    var spec_ed1 = jQuery('#ewz_restricts_f' + sid + '_' ).find('td:not(:contains(" *  "))').find('select[name^="restrictions"]').html();
    var spec_ed2 = jQuery('#ewz_restricts_f' + sid + '_' ).find('td:not(:contains(" *  "))').find('select[name^="restrictions"]').find('option:eq(0)').not(":selected").html();
    if ( ( undefined !== spec_ed1 && spec_ed1.length > 0 )  && ( undefined == spec_ed2 || spec_ed2.length < 1 ) ) {
        err_alert(sid, ewzG.errmsg.one_spec);
        ok = false;
    }   
         
    jform.find('div[id^="add_restr_"]').each(function() {
        var spec = jQuery(this).find('select[name^="restrictions"]').find('option:eq(0)').not(":selected");
        if (undefined !== spec && spec.length < 1) {
           err_alert( sid, ewzG.errmsg.all_any );      
            ok = false;
        } else if (undefined !== spec && spec.length < 2) {
            err_alert( sid, ewzG.errmsg.one_any );
            ok = false;
        }
    });
         
    return ok;
}    

function do_submit(jform, sid, copy_restr_from ){
    var except2;
    var jwaitpanel;
    copy_restr_from = ( typeof copy_restr_from !== 'undefined') ? copy_restr_from : -1;
    if( copy_restr_from >= 0 ) {
        jwaitpanel = jQuery('#ewz_control').find('td[class="ewz_waitmessage"]');
    } else {
        jwaitpanel = jform.find('td[class="ewz_waitmessage"]');
    }
    jwaitpanel.html('Processing, please wait ... <img alt="Please Wait" src="' + ewzG.load_gif + '"/>');

    try {

        // enable all the disabled stuff so right data gets sent
        jform.find('select:disabled,input:disabled,textarea:disabled,button:disabled').prop("disabled", false);
        jform.find('input[id$="optrow_"]').prop("disabled", true);  // we DO want this disabled
        jQuery('#ewz_layout_fields' + sid).find(":input").prop("disabled", true);  // and this

        jform.append('<input type="hidden" name="action" value="ewz_scheme_changes" />');
        if(copy_restr_from >= 0 ){
            jform.append('<input type="hidden" name="copy_restr_from", value="' + copy_restr_from + '">');
        }
        jform.append('<input type="hidden" name="ewznonce" value="' + jQuery('#ewznonce').val() + '">');
        
        // ajaxurl variable is available in admin
         jQuery.post(ajaxurl,
                    jform.serialize(),
                    function(response) {
                        if( response.success ){
                            process_saved_copy( sid, response );
                        } else {
                            ewz_alert( 'RS009', 'Error, scheme not saved ' + response.data, ++popupN);
                            disable_ss_options('.ssc' + sid);
                            disable_restricted_fields(sid);
                        }
                        g_doingSubmit = false;
                        g_changesMade = false;
                        jwaitpanel.html('');
                    }).fail(  function( jqXHr, textStatus, errorThrown ) { 
                        ewz_alert( 'RS014', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );
                        jwaitpanel.html('');
                        g_doingSubmit = false;
                    });
                      
    } catch (except2) {
        ewz_alert("RS010", "Sorry, there was an unexpected error: " + except2.message, ++popupN);
        jwaitpanel.html('');
        return true;   // should make regular submit work
    }
}


function process_saved_copy( sid, response ){

    var oldname = '';
    var new_sid = response.data.rating_scheme_id;
    var newL = '<option value="' + new_sid + '">' + response.data.scheme_name + '</option>';
    var index = js_find_by_key( ewzG.schemes, 'rating_scheme_id', sid );
    if( index > -1 ){
        oldname = ewzG.schemes[index].scheme_name;
        if( oldname != response.data.scheme_name ){
            jQuery('#ewz_addscheme > option[value="' + new_sid + '"]').replaceWith(newL);
        }
        ewzG.schemes[index] = response.data;
    } else {
        ewzG.schemes.push(response.data);
        jQuery('#ewz_addscheme').append(newL);
        ewzG.schemes_options += newL;
    }
    jQuery('#ewz_admin_schemes_f' + sid + '_').replaceWith( scheme_str( new_sid, response.data) );
    setup_scheme(new_sid);
    schemes_done[new_sid] = true;
    var loc = jQuery('#ewz_admin_schemes_f' + new_sid + '_').position().top - 50;
    jQuery('html, body').scrollTop( loc );
    ewz_alert('RS015', 'Saved Scheme "' + response.data.scheme_name + '"', ++popupN );
}

/************************ Utility Functions  ****************************************/

function get_scheme_ident(element) {
    var id = jQuery(element).closest('div[id^="ewz_admin_schemes"]').attr('id');
    return id.replace('ewz_admin_schemes_f','').replace('_','');
}

function req_no_max(checkbox){
    if( jQuery(checkbox).is( ":checked" ) ){
        jQuery(checkbox).closest('table[class="ewz_rfield"]').find('[id$="_fdata_chkmax_"]').attr("value", 0).prop("disabled", true);
    } else {
       jQuery(checkbox).closest('table[class="ewz_rfield"]').find('[id$="_fdata_chkmax_"]').prop("disabled", false);
    }
}

/* return true if the field has been selected to show in the field box */
function is_field_displayed( field_id, rating_fields ){
    for( var r in  rating_fields ){
        if( rating_fields.hasOwnProperty( r ) ){
            if( 'fix' == rating_fields[r].field_type && rating_fields[r].fdata['field_id'] == field_id ){
                return true;
            } 
        }
    }
    return false;
}

function is_key_displayed( key, rating_fields ){
    for( var r in  rating_fields ){
        if( rating_fields.hasOwnProperty( r ) ){
            if( 'xtr' == rating_fields[r].field_type &&  rating_fields[r].fdata['dkey'] == key ){
                return true;
            } 
        }
    }
    return false;
}

function err_alert( schemenum, msg )
{
    if( !ewz_errors_done[schemenum + ': ' +  msg] )
    { 
        ewz_errors_done[schemenum + ': ' + msg] = true;
        ewz_alert('RS016', msg, ++popupN); 
    }
}


