'use strict';
var g_next_after = 0;

/***  To display select boxes as radio buttons ***/

function ReplaceSelectWithButtons(selectField) {
    // get the basics
    var jselectField = jQuery(selectField); 
    var selectValue = jselectField.val();
    var selectId = jselectField.attr('id');
    jselectField.parent().css({display: "block"});
    // get all options and create buttons
    jselectField.find('option').each(function() {
        if (jQuery(this).val()) {
            var btn = jQuery('<div data-value="' + jQuery(this).val() + '" data-target="' + selectId  + '" class="ewz-repl-btn">' + jQuery(this).text() + '</div>');
            if (jQuery(this).val() == selectValue) {
                btn.addClass('ewz_repl_selected');
            }
            btn.insertBefore(jselectField);
        }
    });    
    // hide the select field
    jselectField.hide();

    // map click event to buttons
    jQuery(document).on('click', '.ewz-repl-btn', function() {
        var target = jQuery(this).data('target');
        jQuery('.ewz-repl-btn[data-target="' + target + '"]').removeClass('ewz_repl_selected');
        jQuery(this).addClass('ewz_repl_selected');
        
        // deselect everything, select the selected :)
        var selectorAll = '#' + target + ' option';
        jQuery(selectorAll).prop('selected', false);
        var jselectorSingle = jQuery('#' + target + ' option[value="' + jQuery(this).data('value') + '"]');
        jselectorSingle.prop('selected', true);
        jselectorSingle.trigger("change");
    });
}

function ewz_selectorradio(rf_num){
    if( jQuery('#useradio' + rf_num).is(':checked') ){
        // change selects
        jQuery('table.ewz_rating_table select').each(function(){ReplaceSelectWithButtons(this);});
    } else {
        jQuery('span[class^="ewzval_"]').find('div.ewz-repl-btn').remove();
        jQuery('span[class^="ewzval_"]').find('select').show();
    }
    
}



/*****************************************/


var ewz_img_win,  ewz_minw, ewz_minh, ewz_nw, ewz_nh;
var ewz_curr_row;
var ewz_curr_rfnum;
var popupN;  // used for id of popup 
var ewz_img_win_shown = false;
var ewz_throttled, ewz_resizing;
var down = {};

var ewz_selected_row;


jQuery(window).on("load", function() { 
    jQuery('.loading').hide();
    ewz_selected_row = 1;
});

jQuery(document).ready( function() {
    jQuery("img").on("contextmenu",function(){
        return false;
    }); 
    jQuery('img').on('dragstart', function(event) {
        event.preventDefault();
    });
    popupN = 0;
    for ( var wkey1 in window ) {
        if (window.hasOwnProperty(wkey1)) {
            if (wkey1.substring(0, 5) === 'ewzG1') {
                var rf_num = wkey1.substring(6);
                ewz_do_setup( window[wkey1], rf_num );
            }
        }
    }
    
    ewz_ts_sortables_init();
    window.name = 'ewz_mainw';
});

function ewz_setnextafter(select){
    var col = jQuery(select).val();
    if( undefined != col && "" != col ){
        g_next_after = col;
    }
}

    
function positioned_alert( alert_id, msg, pnum, jrow ){
    var title = '** Notice **';
    return jQuery('<div class="alertDiv' + alert_id + '"></div>').html('[' + alert_id + '] &nbsp; ' +  msg ).dialog({
        title: title,
        resizable: true,
        minWidth: 200,
        classes: {
            "ui-dialog": "ewz-dialog"
        },      
        dialogClass: "ewz-dialog",
        modal: true,
        position: { my: "center top", at: "center bottom", of: jrow },
        buttons:[ {
            text:"Ok",
            id: "ewz_alert" + pnum.toString(),
            click: function(){
                jQuery( this ).dialog( "close" );
            }
        }
                ]
    });
}


function ewz_get_judge_help( rfnum ){
    return jQuery('#ewz_jhelp' + rfnum).dialog({
        'title': 'Help ',
        'width': 700,
        height: 600,
        'maxHeight': 700,
        resizable: true,
        classes: {
            "ui-dialog": "ewz-dialog"
        },      
        dialogClass: "ewz-dialog",
        position: {  my: "right top",  at: "right-20 top+100", of: window },
        'closeOnEscape': true,
        'modal'  : false,
        buttons:[ {
            text:"Ok",
            id: "ewz_ok_help",
            click: function() 
            {
                jQuery( this ).dialog( "close" );
            }
        }]
    });
}


function ewz_show_as_judge(jselect, qstr){ 
    var jstring = jQuery(jselect).val();   
    if( jstring.length > 0 ){  
        window.location.search = qstr.replace('j1j1j1', jstring ); 
    } else { 
        window.location.search = qstr.replace(/[?&]?jjj=j1j1j1/, '' );  
    } 
} 

function get_ewzG( rf_num ){
    var ewzG;
    for ( var wkey1 in window ) {  
        if (window.hasOwnProperty(wkey1)) {
            if (wkey1 === 'ewzG1_' + rf_num ) { 
                ewzG = window[wkey1].gvar;
            }
        }
    }
    return ewzG;
}


function ewz_do_setup( ewzG1_NUM, rf_num ) {
    var ewzG_NUM = ewzG1_NUM.gvar;

    if( ewzG_NUM.do_warn ){
        window.addEventListener("beforeunload", function (e) {
            var enabled = jQuery('button[id ^="ewz_savebtn' + rf_num + '_"]:enabled').length;
            var is_admin_preview = ( window.location.search.indexOf('jjj') > 0 );
            if( !is_admin_preview && enabled > 0 ){
                var confirmationMessage = "Really leave without saving your " + enabled + " unsaved items?";
                (e || window.event).returnValue = confirmationMessage; //Gecko + IE
                return confirmationMessage;                            //Webkit, Safari, Chrome
            }
        });
    }
    if( ewzG_NUM.errmsg  ){
        var curr = jQuery('.alertDivJR001').html();
        var val = jQuery("<textarea/>").html(ewzG_NUM.errmsg).text();
        if( !( curr && curr.includes( val ) ) ){
            ewz_alert( 'JR001', ewzG_NUM.errmsg, ++popupN );
        }
    }
    var img_fields = [];
    for( var fid in ewzG_NUM.fields ){
        if( ewzG_NUM.fields.hasOwnProperty(fid) ){
            if( ewzG_NUM.fields[fid].fixfield != undefined && ewzG_NUM.fields[fid].fixfield.field_type  == 'img'){
                img_fields.push( ewzG_NUM.fields[fid].rating_field_id );
            }
        }
    }
    ewzG1_NUM.gvar.img_fields = img_fields;

    var tid = '#ewz_rtable_' + ewzG_NUM.rf_num;
    if( img_fields.length > 1 ){
        ewz_fixLinks(jQuery(tid).find('tbody').get());
    }

    jQuery(tid).css("background-color", ewzG_NUM.bg_main);

    jQuery(tid).find('td').each( function(){  ewz_set_ts_custom( jQuery(this)); });



    // After all ajax calls are finished, update the ewz_jstatus div with the new counts
    if( !ewzG_NUM.no_save ){
        jQuery( document ).ajaxStop(function() {
            if( jQuery('#ewz_jstatus').length ){
                var the_nonce = jQuery('.ewz_rtable').find('input[name="ewzratingnonce"]').first().val();
                var jqxhr = jQuery.ajax({  type: "POST",  
                                           url: ewzG_NUM.ajaxurl,  
                                           data: {
                                               action: 'ewz_get_judge_count',
                                               judge_id: ewzG_NUM.jid,
                                               rating_form_id: ewzG_NUM.rf_id,
                                               ewzratingnonce: the_nonce
                                           },  
                                           success: function(response, textStatus,  jq) { 
                                               if ( response.match(/.*Items saved/) ) {
                                                   var oldstatus = jQuery('#ewz_jstatus').html();

                                                   if( oldstatus ){
                                                       jQuery('#ewz_jstatus').html( oldstatus.replace( /^.*Items saved/, response) );
                                                   }
                                                   var d = new Date();
                                                   if( d.getTime() > ewzG_NUM.reload_after ){
                                                       document.location.reload(true); 
                                                   }
                                               } else {
                                                   ewz_alert( 'JR003', response, ++popupN );
                                               }
                                           },
                                           error:  function( response, textStatus, errorThrown ){
                                               ewz_alert( 'JR016', 
                                                          'Sorry, there was an error when getting the "Items Saved" status: ' + errorThrown,
                                                          ++popupN 
                                                        );
                                           },
                                           dataType: 'text',
                                           global: false
                                        });
            }
        }); 
    }
    ewzG_NUM.warn_after = parseInt( ewzG_NUM.warn_after );
    jQuery(document ).on("keydown",  function(e) { adjacent_item(e); });
    jQuery(document ).on("keyup", function(e) { down[e.which] = null; });
    ewz_selectorradio(ewzG_NUM.rf_num);
    ewz_setnextafter(document.getElementById('nextafter' + ewzG_NUM.rf_num));
}



// needed for sorting -- set the "ts_custom" attribute of the cell
function ewz_ts_set( rf_num, inpt, field_id=0){
    var ts_value;
    var jinpt = jQuery( inpt );
    var ewzG = get_ewzG(rf_num);
    var jcell = jinpt.closest('td');
    ewz_set_ts_custom( jcell );

    var jtr = jcell.closest('tr');
    jtr.find('button[class^="ewz_savebtn"]').prop('disabled',false);
    jtr.find('button[class^="ewz_clearbtn"]').prop('disabled',false);

    var rownum =  jtr.index();
    if( rownum != ewz_curr_row || rf_num != ewz_curr_rfnum ){
        var notsaved = ewz_count_not_saved( rf_num );
        if( notsaved >= ewzG.max_unsaved ){
            ewz_alert( "JR020", "There are " + notsaved + " unsaved items. You risk losing data if you do not save them before making more changes.", ++popupN );
            ewz_curr_row = rownum;
            ewz_curr_rfnum = rf_num;
        }
    }
    var d = new Date();
    if( d.getTime() > ewzG.warn_after ){
        ewz_alert( 'JR004', document.title + "\nYour access to this page will eventually expire if you do not save something.\nTo avoid losing data, you should save your changes now.  The page should then refresh.", ++popupN );
        ewzG.warn_after = ewzG.warn_after + ewzG.interval;   
    }
    if( (g_next_after > 0) && (field_id ==  g_next_after) ){
        ewz_image_window( rf_num, rownum + 1, 0 );
    }
}

function  ewz_set_ts_custom( jcell ){
    var tval = '';
    jcell.find('*').each( function(){
        if( undefined !==  jQuery(this).attr('ewzsorton') ){
            switch( jQuery(this).attr('ewzsorton') ){
            case 'txt': 
                tval += jQuery(this).text().substring(0,50);
                break;
            case 'val':  
                tval += jQuery(this).val().substring(0,15);
                break;
            case 'chk':
                tval += jQuery(this).is(':checked') ? '1':'0';
                break;
            }
        }
    });
    jcell.attr('ts_custom', tval);
}


//************* Image Display and Sorting Functions ************

// onClick for the clear button at the end of each row
function ewz_clear_row( rf_num, button ){
    var ewzG = get_ewzG( rf_num );
    var jbutton = jQuery(button);
    
    var jrow = jbutton.closest('tr');
    jbutton.prev("button").prop('disabled', false );
    var has_saved = ( parseInt( jbutton.closest('td').find('input[name="item_rating_id"]').val() ) > 0 );

    if( !has_saved ){   
        ewz_blank_row( jrow );
    } else {
        ewz_confirm( 'This will delete all the responses you saved for this item, and cannot be undone.  Are you sure?',
                     function(){ ewz_delete_saved_rating( ewzG, jrow, jbutton); },
                     null,
                     ++popupN );
    }
}

function ewz_blank_row( jrow ){
    jrow.find("input:text").closest('td').attr('ts_custom', '');
    jrow.find("input:text").val('').attr("value", '');

    jrow.find("input:radio").closest('td').attr('ts_custom', '');
    jrow.find("input:radio").prop("checked", false ).attr("checked", false );

    jrow.find("input:checkbox").closest('td').attr('ts_custom', '');
    jrow.find("input:checkbox").prop("checked", false ).attr("checked", false );

    jrow.find("option").prop("selected", false ).attr("selected", false ).prop("disabled", false);

    jrow.find("select").closest('td').attr('ts_custom', '');
    jrow.find("select").val('');

    jrow.find("textarea").closest('td').attr('ts_custom', '');
    jrow.find("textarea").val('').attr("value", '');

    jrow.addClass('ewz_new');
    jrow.find('input[name="item_rating_id"]').attr("value", "0");
    jrow.find('button').prop("disabled", true ); 
}

function ewz_delete_saved_rating( ewzG, jrow, jbutton ){
    if( ewzG.no_delete ){
        ewz_alert( 'JR015', ewzG.nosavemsg, ++popupN);
        ewz_blank_row( jrow );
    } else {

        jbutton.after('<input type="hidden" id="ajax_action" name="action" value="ewz_delete_rating" /> ' +
                      '<input type="hidden" id="view" name="view" value="' + ewzG.view + '">' +
                      '<input type="hidden" id="judge_id" name="judge_id" value="' + ewzG.jid + '"/>');
        var str =  jrow.find( "input, textarea, select" ).serialize();
        var callback = jQuery.proxy( ewz_process_delete_response, this, jbutton, jrow );

        var jqxhr = jQuery.post( ewzG.ajaxurl,
                                 str,
                                 callback
                               ).fail( function( jqXHr, textStatus, errorThrown ){ewz_alert( 'JR017', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );
    }
}

function ewz_process_delete_response(  jbutton, jrow,  response )
{
    jQuery('#ajax_action' ).remove();
    jQuery('#view' ).remove();
    if ( response.match(/^1$/) ) {
        ewz_blank_row( jrow );
    } else {
        ewz_alert( 'JR014', response, ++popupN );
    }
}

function  adjacent_item(e){
    if( !e.target.tagName.toUpperCase().match("TEXTAREA|INPUT" )){
        // ewz_selected_row gets set in ewz_image_window
        var rf_num = ewz_curr_rfnum;
        var key = e.which;
        if (down[key] == null){
            switch(key) {
            case 37: // left
                ewz_image_window( rf_num, ewz_selected_row - 1, 0 );
                down['37'] = true;
                break;
            case 39: // right
                ewz_image_window( rf_num, ewz_selected_row + 1, 0 );
                down['39'] = true;
                break;
            default: return; // exit this handler for other keys
            }
        }
        e.preventDefault(); // prevent the default action ( move caret)
    }
}

/****************************** Main Image Window ********************************************/
function ewz_show_image2( rf_num, rownum, the_content, rating_field_id ){
    var ewzG = get_ewzG( rf_num );
    if(  !ewz_img_win || ewz_img_win.closed || ( undefined == ewz_img_win  ) || ( ewz_img_win == null ) || ( ewz_img_win.top == null ) ){

        var avail_h = window.screen.availHeight - 80; // -80 for url-bar and window decorations
        var avail_w = window.screen.availWidth - 130; // leave some space on each side for nav buttons

        var rwin_h = Math.min( avail_h,  parseInt(ewzG.maxh) + parseInt(ewzG.img_pad) + 70 );  // 50 for link below image
        var rwin_w = Math.min( avail_w,  parseInt(ewzG.maxw) ) + 130; 

        ewz_img_win = window.open( '', 'Rating', 'height=' + rwin_h + ',width=' + rwin_w + ',menubar=0,toolbar=0,status=0,resizable=1,scrollbars=1' );
        var styl =  ewz_img_win.document.createElement('link');
        styl.rel = "stylesheet";
        styl.type='text/css';
        styl.href = ewzG.styleFile;
        ewz_img_win.document.head.appendChild(styl);

        ewz_img_win.document.body.style.background = ewzG.bcol;
        ewz_img_win.document.body.style.color = ewzG.fcol;
        ewz_img_win.document.body.style.margin = "0px";

        jQuery(ewz_img_win.document.body ).on("keydown",  function(e) { adjacent_item(e); });
        jQuery(ewz_img_win.document.body ).on("keyup",  function(e) { down[e.which] = null; });

    } else {
        ewz_img_win.focus();   // NB: this is javascript, not jquery
    }

    var content;
    if( !ewz_img_win_shown ){
        // force initial display of test image
        content =  ewz_test_img_display(rf_num, rownum, rating_field_id, true );
        ewz_img_win_shown = true;
    } else if(  0 === the_content.length || !the_content.trim() ){
        // no content, "show test image" button was clicked
        content =  ewz_test_img_display(rf_num, rownum, rating_field_id, false );
    } else {
        content = the_content;
    }
    ewz_img_win.document.body.innerHTML = content;  

    var jcontainer = jQuery(ewz_img_win.document.body ).find('div[id^="imgcontainer"]').first(); 
    jcontainer.css({'top':  ewzG.img_pad +  'px', 'background': ewzG.bcol });

    var jimg = jQuery( ewz_img_win.document.body ).find( "img" ).first();

    jimg.on( "load",  function(){
        ewz_minw = parseInt( jimg.css('min-width').replace('px',''));
        ewz_minh = parseInt( jimg.css('min-height').replace('px',''));

        var img = jimg["0"];
        ewz_nw = img.naturalWidth;
        ewz_nh = img.naturalHeight;
        ewz_show_dimensions();
        ewz_throttled = false;
        jimg.on("contextmenu",function(){
            return false;
        }); 
        jimg.on('dragstart', function(event) {
            event.preventDefault();
        });
        jQuery( ewz_img_win ).on("resize", function() {
            if( !ewz_throttled ){
                ewz_show_dimensions();
                ewz_throttled = true;
                setTimeout(function() {
                    ewz_throttled = false;
                }, 500 );
            }
            clearTimeout(ewz_resizing);
            ewz_resizing = setTimeout( function() {
                ewz_show_dimensions();           
            }, 250 );
        });
    }) ;
    
}

function ewz_toggle_full_size( ident ){
    var jimg = jQuery( ewz_img_win.document.body ).find( "img" );
    if( jimg.hasClass('mainsized') ){
        jimg.removeClass('mainsized');
        var style = 'width:' + ewz_nw + 'px;height:' + ewz_nh + 'px;';
        jimg.css(style);
        jQuery(ewz_img_win.document.body ).find('div.ewz_size').text('');
    } else {
        jimg.addClass('mainsized');
        jimg.load();
    }  
}

function ewz_show_dimensions( ){
    var jspan = jQuery( ewz_img_win.document.body ).find( "div.ewz_size" );
    if( jspan.length ){
        var jimg = jQuery( ewz_img_win.document.body ).find( "img" );
        var w = jimg.width(), h=jimg.height();
        var pct = (100 * (w/ewz_nw) ).toFixed(0);
        var cntr = jQuery(ewz_img_win.document.body ).find('div[id^="imgcontainer"]')[0]; 
        var errstyle = 'background: #b94a4a; padding-right: 20px; padding-left: 20px;';
        jQuery(ewz_img_win.document.body ).find('button[id^="fullsize"]').show().prop('disabled', false);
        if( ( w < ewz_minw - 1) || (h < ewz_minh - 1) ){
            jspan.html( '<span style="' + errstyle + '">Invalid Dimensions: ' + w + 'x' + h + '( min is ' + ewz_minw + 'x' + ewz_minh + ')</span>');
        } else if( (cntr.scrollHeight > cntr.clientHeight ) || ( cntr.scrollWidth > cntr.clientWidth )) {
            jspan.html( '<span style="' + errstyle + '">Window is too small</span>');
        } else if ( ( w < ewz_nw ) || ( h < ewz_nh ) ) {
            jspan.html( 'Dimensions ' + pct + '% of actual.' ); 
        } else {
            jQuery(ewz_img_win.document.body ).find('button[id^="fullsize"]').prop('disabled', true).hide();
            jspan.html(' ');
        }
    }
}

function ewz_image_window( rf_num, rownum, rating_field_id ) {
    var ewzG = get_ewzG( rf_num );
    ewz_curr_rfnum = rf_num;
    if( rownum >= 0  && rownum < ewzG.num_rows ){  
        if( rating_field_id == 0 ){
            rating_field_id = ewzG.img_fields[0];
        }
        ewz_selected_row = rownum;
        
        jQuery('#ewz_rtable_' + rf_num + ' > tbody > tr' ).attr("style", "background: " + ewzG.bg_main + ";");
        jQuery('#ewz_rtable_' + rf_num + ' > tbody > tr > td ' ).attr("style", "background: " + ewzG.bg_main + ";");

        // change the background of the currently-selected image row ( counts from 1, not 0 )        
        var rnum = rownum + 1;
        var jrow =  jQuery('#ewz_rtable_' + rf_num + ' > tbody > tr:nth-of-type(' + rnum + ')');
        jrow.attr("style", "background: " + ewzG.bg_curr + ";");
        jQuery('#ewz_rtable_' + rf_num + ' > tbody > tr:nth-of-type(' + rnum + ') > td ' ).attr("style", "background: " + ewzG.bg_curr + ";");

         
        // scroll the scoring page to the item 
        jQuery("body, html").animate({ scrollTop: jrow.offset().top - 100 }, {}, 600);

        // set up the html and add the content, which is stored hidden in the last column of #ewz_rtable
        var content = jQuery('#ewz_rtable_' + rf_num + ' > tbody > tr:nth-of-type(' + rnum + ')').find('div[class^="ewz_rating_page_' + rating_field_id + '"]').html();
        ewz_show_image2( rf_num, rownum, content, rating_field_id );
        
        // hide the next link on the last image, and the previous link on the first
        if( rownum == 0 && ( rating_field_id == ewzG.img_fields[0] ) ){ jQuery('body', ewz_img_win.document ).find('button[id^="prevbtn"]').hide(); }
        if( rownum == ( ewzG.num_rows - 1 ) && ( rating_field_id == ewzG.img_fields[ewzG.img_fields.length-1] ) ){ jQuery('body', ewz_img_win.document ).find('button[id^="nextbtn"]').hide(); }
    }

}


function ewz_test_img_display( rf_num, return_row, rating_field_id, is_first ){
    var ewzG = get_ewzG( rf_num );
    var label =  is_first ? "OK" : (return_row > 0 ) ? "Back" :  "To First Image";
    var minImgW = Math.ceil( (ewzG.max_shrink * ewzG.maxw )/100 );
    var minImgH = Math.ceil( (ewzG.max_shrink * ewzG.maxh )/100 );
    var imgStyle = " min-width: " + minImgW + 'px;  min-height:' + minImgH + "px;";
    
    var content = '<div id="imgcontainer00"  class="ewz_imgcntr"> ';
    if(is_first){
        content += '<div class="notice" style=" top:' + ( ewzG.img_pad + 100 ) + 'px;">';
        content +=  ewzG.init_img_text + '</div>';
    }
    content +=     '<img  id="mainimg00" class="mainsized" onContextMenu="return false;" src="' + ewzG.testimg + '" style="' + imgStyle + '">';

    content += '</div>';
    content += '<div id="imgnav00">';
    content += '   <button type="button" class="ewz_test_btn" id="backImgBtn00" onClick="opener.ewz_image_window(' + rf_num + ',' + return_row + ', ' + rating_field_id + ' )">' + label + '</button>';
    content += " &nbsp; &nbsp; <div class='ewz_size'>  </div>";
    content += '</div>  ';
    
    return content;
}


/**************************************************************************************/


// call to this added to table-sorting script by js to keep the 'next', 'previous' and test-image links 
// working after a sort
function ewz_fixLinks( link ){

    var jtable = jQuery(link).closest( 'table[id^="ewz_rtable_"]' );
    var rf_num = jtable.attr("id").substring(11);
    var ewzG = get_ewzG( rf_num );
    var jrows = jtable.find('tbody').children();
    for ( var i = 0; i < ewzG.img_fields.length; i++ ){
        jrows.find('[id^="nextbtn' + ewzG.img_fields[i] + '"]').each( function( index ){
            var adj =  adjacent_img( ewzG.img_fields, ewzG.img_fields[i], index, 'next' );
            jQuery(this).attr("onclick","opener.ewz_image_window( " + rf_num + ", " + adj[0] + ", " + adj[1] + " )");
        });
        jrows.find('[id^="prevbtn' + ewzG.img_fields[i] + '"]').each( function( index ){
            var adj =  adjacent_img( ewzG.img_fields, ewzG.img_fields[i], index, 'prev' );
            jQuery(this).attr("onclick","opener.ewz_image_window( " + rf_num + ", " + adj[0] + ", " + adj[1] + " )");
        });     
        jrows.find('[id^="testbtn' + ewzG.img_fields[i] + '"]').each( function( index ){
            // rating-field-id, row
            jQuery(this).attr("onclick","opener.ewz_show_image2( " + rf_num + ", " + index + ", '', " +  ewzG.img_fields[i] + " )");
        });     
        jrows.find('img.ewz_thumb[id$="' + ewzG.img_fields[i] + '"]').each( function( index ){
            jQuery(this).attr("onclick","ewz_image_window( " + rf_num + ", " + index + ", " +  ewzG.img_fields[i] + " )");
        });

    }
    if( ( ewz_img_win !== undefined ) && ( ewz_img_win.top !== null ) ){
        ewz_image_window( rf_num, 0, 0);
    }
}

function adjacent_img( img_fields, rfield_id, rowindex, next_prev ){
    var img_index = img_fields.indexOf(rfield_id);
    var max_index = img_fields.length - 1;
    if( next_prev == 'next' ){

        if( img_index < max_index ){
            return [ rowindex, img_fields[img_index + 1] ];
        } else {
            return [ rowindex + 1, img_fields[0] ];
        }
    } else {
        if( img_index > 0 ){
            return [ rowindex, img_fields[img_index - 1] ];
        } else {
            return [ rowindex - 1, img_fields[max_index] ];
        }
    }
}


// jump to the first unrated item
function ewz_to_next_item( rf_num ){
    var ewzG = get_ewzG( rf_num );
    var jrow = jQuery('tr[class="ewz_new"]').first();

    if(  undefined !== jrow ){       
        jQuery("body, html").animate({ scrollTop: jrow.offset().top - jrow.height() }, {}, 600);
        ewz_image_window( rf_num, jrow.index(), ewzG.img_fields[0] );
    }
    
}

//************* Judge Finished ************
function ewz_judge_finished( rf_num ){
    var ewzG = get_ewzG( rf_num );
    var notsaved = ewz_count_not_saved( rf_num );
    if( notsaved > 0 ){
        ewz_alert( "JR005", "There are still " + notsaved + " unsaved items. Please save them first.", ++popupN );
        return;
    }
    if( ewz_check_all_rows( ewzG, rf_num ) ){
        ewz_confirm( "This will remove your access to the page. Are you sure you are completely finished? ",
                     function(){ 
                         ewz_do_judge_finished(ewzG, rf_num);
                     },
                     null, ++popupN );
    }
}

function ewz_do_judge_finished(ewzG, rf_num){
    if( ewzG.no_save ){
        ewz_alert( 'JR006', ewzG.nosavemsg, ++popupN);
    } else {
        var the_nonce = jQuery('#ewz_rtable_' + rf_num).find('input[name="ewzratingnonce"]').first().val();
        var jqxhr = jQuery.post( ewzG.ajaxurl,
                                 {
                                     action: 'ewz_done',
                                     judge_id: ewzG.jid,
                                     rating_form_id: ewzG.rf_id,
                                     ewzratingnonce: the_nonce
                                 },                            
                                 function(response) { 
                                     if ( response == '1') {
                                         document.location.reload(true);
                                     } else {
                                         ewz_alert( 'JR007', response, ++popupN );
                                     }
                                 }
                               ).fail( function( jqXHr, textStatus, errorThrown ){ ewz_alert( 'JR018', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} ); 
    }       
}



function ewz_count_not_saved( rf_num ){
    var notsaved = 0;
    jQuery('#ewz_rtable_' + rf_num).find('button[class^="ewz_savebtn"]').each( function(){
        var jthis = jQuery(this);
        if( !jthis.prop("disabled")){    
            ++notsaved;
        }
    });
    return notsaved; 
}


function ewz_check_all_rows(  ewzG, rf_num ){
    var has_error = false;
    jQuery('#ewz_rtable_' + rf_num).find('button[class^="ewz_savebtn"]').each( function(){
        var row_status =  ewz_check_row( rf_num, ewzG, this );
        switch ( row_status ) {
        case 'req': has_error = true ; return false;
            break;
        case 'restr': has_error = true ; return false;
            break;
        }
    });
    return !has_error;

}


//************* Checks Before Saving ************
var ewz_alert_done;
function ewz_check_required( rf_num, ewzG, jrow, fvalues ){
    if( !ewzG.jsvalid ){
        return true;
    }
    for( var fid in ewzG.fields ){
        if( ewzG.fields.hasOwnProperty(fid) ){
            if( ( ( ewzG.view == 'rate' ) || ( ewzG.fields[fid].is_second && ( ewzG.view == 'secondary' ) ) )  && 
                ( ewzG.fields[fid].required ) && 
                ( jrow.find('[name="rating[' + fid +']"]').length > 0 )  &&  isblank( fvalues[fid][0] ) 
              ){
                // hilite the problem item and move to it
                ewz_image_window( rf_num, jrow.index(), 0 );         
                var thetop =  jrow.offset().top - jrow.height();
                var ewz_animate_done = false;   // need both html and body in next line, may find both
                jQuery("html").animate(
                    { scrollTop: thetop }, 
                    {  complete: function() { ewz_animate_done = true; },
                       duration: 600
                    });
                if( !ewz_animate_done ){
                    jQuery("body").animate({ scrollTop: thetop },  { duration: 600 } );
                }
                jQuery('html').scrollTop(thetop);    // this code is executed before the animate finishes                  
                jQuery('body').scrollTop(thetop);    // so a scroll is required before the popup shows                  
                positioned_alert( "JR008", "Items Not Saved: " +  ewzG.fields[fid].field_header + " is required.", ++popupN, jrow );
                
                return false;
            }
        }
    }
    return true;
}

/* If any restrictions are not satisfied, show an ewz_alert and return false */
/* Otherwise, return true                                                */
function ewz_restrictions_check( rf_num, ewzG, jrow, fvalues ){
    if( ewzG.view == 'read' ){
        return true;
    }
    if( ewzG.view == 'secondary' ){
        return true;
    }
    if( !ewzG.jsvalid ){
        return true;
    }
    for ( var restr1 in ewzG.restrictions) { 
        if (!ewzG.restrictions.hasOwnProperty(restr1)) { continue; }
        var msg = ewzG.restrictions[restr1].msg;
        var row_matches_restr = true;     

        // set row_matches_restr for the row to false if any field does not match
        for ( var field_id in ewzG.fields) {
            if (!ewzG.fields.hasOwnProperty(field_id)) { continue; }
            var field_restrs = ewzG.restrictions[restr1][field_id];
            if( field_restrs !== undefined ){
                var field_val = fvalues[field_id][0];
                if( field_val == undefined ){  // e.g. is field is secondary and view is not
                    field_val = '';
                }
                var field_matches_restr = ewz_r_field_matches_restr( field_restrs, field_val.replace('Self: ', '') );
                row_matches_restr = row_matches_restr && field_matches_restr;
                if( !row_matches_restr ){
                    break; 
                }
            }
        }

        // if row_matches_restr is still true, ewz_alert and return false
        if ( row_matches_restr ) {
            // hilite the problem item and move to it
            ewz_image_window( rf_num, jrow.index(), 0 );                  // select the problem item
            ewz_alert_done = false;   // need both html and body in next line, may find both
            jQuery('html, body').animate({ scrollTop: jrow.offset().top - jrow.height() }, 
                                         { complete: function(){ 
                                             if( !ewz_alert_done ){
                                                 jrow.find('button').first().trigger("focus");  // otherwise goes to top on close
                                                 ewz_alert( "JR009", "Items Not Saved: " + ewzG.restrictions[restr1].msg + "." , ++popupN); 
                                                 ewz_alert_done = true;
                                                 return false;  // otherwise goes to top on close
                                             }
                                         }
                                         }, 600 );
            return false;
        }
    }
    return true;
}


function ewz_r_field_matches_restr( restriction_vals, entered_val ) {
    var restriction_val;
    for( var r in restriction_vals ){
        if( restriction_vals.hasOwnProperty(r) ){
            switch ( restriction_vals[r] ) {
            case  undefined:
                return true;
            case  '~*~':
                return true;
            case  '~-~':
                if (isblank(entered_val)) {
                    return true;
                }
                break;
            case  '~+~':
                if (!isblank(entered_val)) {
                    return true;
                }
                break;
            default:
                if( restriction_vals[r] == entered_val ) {
                    return true;
                }
                break;
            }
        }
    }
    return false;
}

function ewz_check_max_counts( rf_num, ewzG ){
    if( !ewzG.jsvalid ){
        return true;
    }
    for ( var fnum in ewzG.fields ) { 
        if( ewzG.fields.hasOwnProperty(fnum) ){
            var field = ewzG.fields[fnum];
            var ftype = field.field_type; 
            if ( ftype === 'chk' ){
                var maxn = field.fdata['chkmax'] ;
                if( maxn !== undefined && maxn > 0) { 
                    if ( maxn < jQuery( '#ewz_rtable_' + rf_num  + ' input:checked[name="rating[' + field.rating_field_id + ']"]' ).length ){
                        ewz_alert( "JR010", "Items Not Saved: No more than " + maxn + " items may have " +  field.field_header + " checked.", ++popupN );
                        return false;
                    }  
                }              
            }
        }
    }
    return true;
}

function ewz_check_row( rf_num, ewzG, button ){
    var jbutton = jQuery(button);
    var jrow = jbutton.closest('tr');
    var fvalues = ewz_get_inputs( ewzG, jrow);
    var req_check = ewz_check_required( rf_num, ewzG, jrow, fvalues );
    if( !req_check ){
        return 'req'; 
    }
    if( jrow.hasClass('ewz_new') ){
        var all_blank = true;
        for ( var fnum in ewzG.fields ) { 
            if( ewzG.fields.hasOwnProperty(fnum) ){
                var field = ewzG.fields[fnum];
                var ftype = field.field_type; 
                if( !( ftype == 'fix' || ftype == 'xtr' || ftype == 'lab' ) ){
                    if( !isblank( fvalues[field.rating_field_id][0] ) ){
                        all_blank = false;
                        break;
                    } 
                }
            }
        }
        if( all_blank ){
            return 'blank';
        }
    }
    var restr_check = ewz_restrictions_check( rf_num, ewzG, jrow, fvalues );
    if( restr_check ){
        return 'ok';
    } else {
        return 'restr';
    }
}

function ewz_get_inputs( ewzG, jrow)
{
    // second array value not needed now but will be if we ever add maxcounts to option lists
    var fvalues = {}, fid, jelem, fixval,fixdisplay;
    for (var i in ewzG.fields) {
        if (!ewzG.fields.hasOwnProperty(i)) { continue; }
        fid = ewzG.fields[i].rating_field_id;
        switch(ewzG.fields[i].field_type){
        case 'fix': 
            fixval = jrow.find('span[class="ewzval_' + fid + '"]').find('img').attr("src");
            if( ( fixval !== undefined ) && ( fixval.length > 0 ) ){
                fvalues[fid] = [ fixval, fixval ];
                break;
            }
        case 'xtr':
        case 'lab':
            fixval = jrow.find('[class="ewzval_' + fid + '"]').text();
            fvalues[fid] = [ fixval, fixval ];
            break;
        case 'str':
            jelem = jrow.find(':input[name$="[' + fid + ']"]');
            fvalues[fid] = [ jelem.val(), jelem.val() ];
            break;
        case 'opt':
            jelem = jrow.find(':input[name$="[' + fid + ']"] option:selected');
            fvalues[fid] = [ jelem.val(), jelem.text() ];
            break;
        case 'chk':
            jelem = jrow.find(':input[name$="[' + fid + ']"]');
            if( jelem.is(':checked') ){
                fvalues[fid] = [ '1', 'checked' ];
            } else {
                fvalues[fid] = [  '', 'checked'  ];
            }
            break;
        }
    }
    return fvalues;
}

//************** Save Changed Items ************

var last_ewz_alert_done;
// onClick for the save button at the end of each row
function ewz_save_changed_rows( rf_num, button ){
    var ewzG = get_ewzG( rf_num );
    var jbutton = jQuery(button);
    var insertion = '<span id="temp_gen" style="text-align:left">Processing, please wait ... <img alt="Please Wait" src="' + ewzG.load_gif + '"/></span>';
    jbutton.after(insertion);

    var good_rows = [];
    var has_error = false;

    var max_check = ewz_check_max_counts( rf_num, ewzG );
    if( max_check ){
        jQuery('#ewz_rtable_' + rf_num).find('button[class^="ewz_savebtn"]').each( function(){
            var jthis = jQuery(this);
            if( !jthis.prop("disabled")){ 
                var row_status = ewz_check_row( rf_num, ewzG, this );
                switch(row_status){
                case 'blank': jthis.prop("disabled", true );  
                    break;
                case 'req':
                case 'restr': has_error = true; return false;  // stop at first error
                    break;
                case 'ok':  good_rows.push( this ); 
                    break;
                }
            }
        } );
        if( !has_error ){
            ewz_save_rows( ewzG, good_rows );
        } 
    }
    jQuery("#temp_gen" ).remove();
}


function ewz_save_rows( ewzG, buttons ){ 
    if( ewzG.no_save ){
        ewz_alert( 'JR011', ewzG.nosavemsg, ++popupN);
    } else {
        for( var row_n = 0; row_n < buttons.length; ++row_n ){
            var jbutton = jQuery(buttons[row_n]);
            var jrow = jbutton.closest('tr');
            jbutton.after('<input type="hidden" id="ajax_action" name="action" value="ewz_save_rating" /> ' +
                          '<input type="hidden" id="view" name="view" value="' + ewzG.view + '"/>' +
                          '<input type="hidden" id="judge_id" name="judge_id" value="' + ewzG.jid + '"/>');
            var str =  jrow.find( "input, textarea, select" ).serialize();
            var callback = jQuery.proxy( ewz_process_response, this, jbutton, jrow );
            jbutton.prop("disabled", true ); 

            var jqxhr = jQuery.post( ewzG.ajaxurl,
                                     str,
                                     callback
                                   ).fail( function( jqXHr, textStatus, errorThrown ){ ewz_alert( 'JR019', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );} );
        }
        
    }
                                   
}

function ewz_save_judge_prefs(judge_id, rf_num)
{
    var ewzG = get_ewzG( rf_num );

    var the_nonce = jQuery('.ewz_rtable').find('input[name="ewzratingnonce"]').first().val();
    var jqxhr = jQuery.post(  ewzG.ajaxurl, 
                               {
                                   action: 'ewz_set_judge_prefs',
                                   judge_id: judge_id,
                                   useradio: jQuery('#useradio' + rf_num).prop("checked"),
                                   nextafter: jQuery('#nextafter' + rf_num).val(),
                                   ewzratingnonce: the_nonce
                               },
                              ewz_alert(' + ','Settings saved','')
                           ).fail( function( jqXHr, textStatus, errorThrown ){
                               ewz_alert( 'JR021', 'Sorry, there was a server error: ' + jqXHr.responseText, ++popupN );                             } );
}

function ewz_process_response(  jbutton, jrow,  response )
{
    jQuery('#ajax_action' ).remove();
    jQuery('#view' ).remove();
    if ( response.match(/^[1-9][0-9]*$/) ) {
        jrow.removeClass('ewz_new');
        jrow.find('input[name="item_rating_id"]').val(response);
        jbutton.prop("disabled", true ); 
    } else {
        jbutton.prop("disabled", false ); 
        ewz_alert( 'JR012', response, ++popupN );
    }
}

//************** Table Sorting Script ************
/*
  Table sorting script  by Joost de Valk, check it out at http://www.joostdevalk.nl/code/sortable-table/.
  Based on a script from http://www.kryogenix.org/code/browser/sorttable/.
  Distributed under the MIT license: http://www.kryogenix.org/code/browser/licence.html .
  Copyright (c) 1997-2007 Stuart Langridge, Joost de Valk.
  Version 1.5.7
  Date sorting removed  and custom overrides restored ( from the earlier Langridge version )  by Josie Stauffer.
*/

var SORT_COLUMN_INDEX;
var thead = false;

function ewz_ts_sortables_init() {
    // Find all tables with class sortable and make them sortable
    if (!document.getElementsByTagName) return;
    var tbls = document.getElementsByTagName("table");
    for (var ti=0;ti<tbls.length;ti++) {
        var thisTbl = tbls[ti];
        if (((' '+thisTbl.className+' ').indexOf("sortable") != -1) && (thisTbl.id)) {
            var atable = thisTbl;
            ewz_ts_makeSortable(thisTbl);
        }
    }
}

function ewz_ts_makeSortable(t) {
    if (t.rows && t.rows.length > 0) {
        if (t.tHead && t.tHead.rows.length > 0) {
            var firstRow = t.tHead.rows[t.tHead.rows.length-1];
            thead = true;
        } else {
            var firstRow = t.rows[0];
        }
    }
    
    if (!firstRow) return;
    // We have a first row: assume it's the header, and make its contents clickable links
    for (var i=0;i<firstRow.cells.length;i++) {
        var cell = firstRow.cells[i];
        var txt = ewz_ts_getInnerText(cell);
        if (cell.className != "unsortable" && cell.className.indexOf("unsortable") == -1) {
            cell.innerHTML = '<a href="#" class="sortheader" id="' + cell.className + '" onclick="ewz_ts_resortTable(this, '+i+');ewz_fixLinks(this);return false;">'+txt+'&nbsp;<span class="sortarrow">&darr;</span></a>';
        }
    }
}

function ewz_ts_getInnerText(el) {

    if (typeof el == "string") return el;
    if (typeof el == "undefined") { return el; }
    if (el.getAttribute("ts_custom") != null) {
        return el.getAttribute("ts_custom");
    }
    if (el.innerText) return el.innerText;  //Not needed but it is faster
    var str = "";
    
    var cs = el.childNodes;
    var l = cs.length;
    for (var i = 0; i < l; i++) {
        switch (cs[i].nodeType) {
        case 1: //ELEMENT_NODE
            str += ewz_ts_getInnerText(cs[i]);
            break;
        case 3: //TEXT_NODE
            str += cs[i].nodeValue;
            break;
        }
    }
    return str;
}

function ewz_ts_resortTable(lnk, clid) {
    var span;
    for (var ci=0;ci<lnk.childNodes.length;ci++) {
        if (lnk.childNodes[ci].tagName && lnk.childNodes[ci].tagName.toLowerCase() == 'span') span = lnk.childNodes[ci];
    }
    var spantext = ewz_ts_getInnerText(span);
    var td = lnk.parentNode;
    var column = clid || td.cellIndex;
    var t = ewz_ts_getParent(td,'TABLE');
    // Work out a type for the column
    if (t.rows.length <= 1) return;
    var itm = "";
    var i = 0;
    while (itm == "" && i < t.tBodies[0].rows.length) {
        var itm = ewz_ts_getInnerText(t.tBodies[0].rows[i].cells[column]);
        itm = ewz_ts_trim(itm);
        if (itm.substr(0,4) == "<!--" || itm.length == 0) {
            itm = "";
        }
        i++;
    }
    if (itm == "") return; 
    var sortfn = ewz_ts_sortcaseinsensitive;
    if (itm.match(/Self: *\d/)) sortfn = ewz_ts_sortnumeric;   // Added by js 
    if (itm.match(/^-?[£$€Û¢´]\d/)) sortfn = ewz_ts_sortnumeric;
    if (itm.match(/^-?(\d+[,\.]?)+(E[-+][\d]+)?%?$/)) sortfn = ewz_ts_sortnumeric;
    SORT_COLUMN_INDEX = column;
    var firstRow = new Array();
    var newRows = new Array();
    for (var k=0;k<t.tBodies.length;k++) {
        for (i=0;i<t.tBodies[k].rows[0].length;i++) { 
            firstRow[i] = t.tBodies[k].rows[0][i]; 
        }
    }
    for (var k=0;k<t.tBodies.length;k++) {
        if (!thead) {
            // Skip the first row
            for (j=1;j<t.tBodies[k].rows.length;j++) { 
                newRows[j-1] = t.tBodies[k].rows[j];
            }
        } else {
            // Do NOT skip the first row
            for (var j=0;j<t.tBodies[k].rows.length;j++) { 
                newRows[j] = t.tBodies[k].rows[j];
            }
        }
    }
    newRows.sort(sortfn);
    if (span.getAttribute("sortdir") == 'down') {
        var ARROW = '&darr;';
        newRows.reverse();
        span.setAttribute('sortdir','up');
    } else {
        var ARROW = '&uarr;';
        span.setAttribute('sortdir','down');
    } 
    // We appendChild rows that already exist to the tbody, so it moves them rather than creating new ones
    // don't do sortbottom rows
    for (var i=0; i<newRows.length; i++) { 
        if (!newRows[i].className || (newRows[i].className && (newRows[i].className.indexOf('sortbottom') == -1))) {
            t.tBodies[0].appendChild(newRows[i]);
        }
    }
    // do sortbottom rows only
    for (var i=0; i<newRows.length; i++) {
        if (newRows[i].className && (newRows[i].className.indexOf('sortbottom') != -1)) 
            t.tBodies[0].appendChild(newRows[i]);
    }
    // Delete any other arrows there may be showing
    var allspans = document.getElementsByTagName("span");
    for (var ci=0;ci<allspans.length;ci++) {
        if (allspans[ci].className == 'sortarrow') {
            if (ewz_ts_getParent(allspans[ci],"table") == ewz_ts_getParent(lnk,"table")) { // in the same table as us?
                allspans[ci].innerHTML = '&darr;';
            }
        }
    }               
    span.innerHTML = ARROW;
}

function ewz_ts_getParent(el, pTagName) {
    if (el == null) {
        return null;
    } else if (el.nodeType == 1 && el.tagName.toLowerCase() == pTagName.toLowerCase()) {
        return el;
    } else {
        return ewz_ts_getParent(el.parentNode, pTagName);
    }
}


function ewz_ts_sortnumeric(a,b) {
    var aa = ewz_ts_getInnerText(a.cells[SORT_COLUMN_INDEX]);
    aa = ewz_ts_clean_num(aa);
    var bb = ewz_ts_getInnerText(b.cells[SORT_COLUMN_INDEX]);
    bb = ewz_ts_clean_num(bb);
    return ewz_ts_compare_numeric(aa,bb);
}
function ewz_ts_compare_numeric(a,b) {
    var a = parseFloat(a);
    a = (isNaN(a) ? 0 : a);
    var b = parseFloat(b);
    b = (isNaN(b) ? 0 : b);
    return a - b;
}
function ewz_ts_sortcaseinsensitive(a,b) {
    var aa = ewz_ts_getInnerText(a.cells[SORT_COLUMN_INDEX]).toLowerCase();
    var bb = ewz_ts_getInnerText(b.cells[SORT_COLUMN_INDEX]).toLowerCase();
    if (aa==bb) {
        return 0;
    }
    if (aa<bb) {
        return -1;
    }
    return 1;
}
function addEvent(elm, evType, fn, useCapture)
// addEvent and removeEvent
// cross-browser event handling for IE5+,       NS6 and Mozilla
// By Scott Andrew
{
    if (elm.addEventListener){
        elm.addEventListener(evType, fn, useCapture);
        return true;
    } else if (elm.attachEvent){
        var r = elm.attachEvent("on"+evType, fn);
        return r;
    } else {
        ewz_alert("JR013", "Handler could not be removed", ++popupN);
    }
}
function ewz_ts_clean_num(str) {
    var str = str.replace(new RegExp(/[^-?0-9.]/g),"");
    return str;
}
function ewz_ts_trim(s) {
    return s.replace(/^\s+|\s+$/g, "");
}

